'----------------------------------------------------------------------------------------
' PCutility.bas initiated June 16, 2018 Richard Wessel
' Player Character statistic utility for
' Runequest: Roleplaying in Glorantha  (4th Chaosium edition)
' Runequest is a trademark of Moon Design Publications
' Present program version PC Minder 2.0.0 beta  Sept. 11, 2018
' Developed and compiled using QB64 (www.qb64.org)
' version history moved to Comments SUB
'----------------------------------------------------------------------------------------
$EXEICON:'manrune256.ico'
_TITLE "PC Minder (RQG character utility) version 2.0.0"
_SCREENMOVE 20, 20

'VARIABLE DIMENSIONING

'Version
DIM SHARED ver_p AS INTEGER
DIM SHARED ver_s AS INTEGER
DIM SHARED ver_t AS INTEGER
ver_p = 2
ver_s = 0
ver_t = 0
'-----------------------------------------------------------------------------------------
'                                                               ATTRIBUTES
REDIM SHARED hitpoints(10) AS INTEGER '                         Total Hit Points
REDIM SHARED LegHP(10) AS INTEGER '                             Leg Hit Points
REDIM SHARED AbdmHP(10) AS INTEGER '                            Abdominal Hit Points
REDIM SHARED ChstHP(10) AS INTEGER '                            Chest Hit Points
REDIM SHARED ArmHP(10) AS INTEGER '                             Arm Hit Points
REDIM SHARED HeadHP(10) AS INTEGER '                            Head Hit Points
REDIM SHARED magpoints(10) AS INTEGER '                         Magic Points
REDIM SHARED dexsr(10) AS INTEGER '                             DEX Strike Rank
REDIM SHARED sizsr(10) AS INTEGER '                             SIZ Strike Rank
REDIM SHARED basesrm(10) AS INTEGER '                           Base Strike Rank (DEX Strike Rank + SIZ Strike Rank)
REDIM SHARED healrate(10) AS INTEGER '                          Healing Rate
REDIM SHARED dambonus(10) AS STRING '                           Damage Bonus
REDIM SHARED sprtcmbtdam(10) AS STRING '                        Spirit Combat Damage
REDIM SHARED maxenc(10) AS INTEGER '                            Maximum Encumbrance
'----------------------------------------------------------------------------------------
'                                                               CATEGORY BONUSES
REDIM SHARED Agil(10) AS INTEGER '                              Agility Bonus
REDIM SHARED Communi(10) AS INTEGER '                           Communication Bonus
REDIM SHARED Know(10) AS INTEGER '                              Knowledge Bonus
REDIM SHARED Magic(10) AS INTEGER '                             Magic Bonus
REDIM SHARED Manip(10) AS INTEGER '                             Manipulation Bonus
REDIM SHARED Percep(10) AS INTEGER '                            Perception Bonus
REDIM SHARED Stealth(10) AS INTEGER '                           Stealth Bonus
REDIM SHARED Melee(10) AS INTEGER '                             Melee Weapons Bonus
REDIM SHARED Missile(10) AS INTEGER '                           Missile Weapons Bonus
REDIM SHARED Shield(10) AS INTEGER '                            Shield Bonus
REDIM SHARED Natur(10) AS INTEGER '                             Natural Weapons Bonus
'----------------------------------------------------------------------------------------
'                                                               PERSONAL/CULTURAL
REDIM SHARED MyHome(10) AS STRING * 15 '                        Homeland
REDIM SHARED Occup(10) AS STRING * 15 '                         Occupation
REDIM SHARED PCname(10) AS STRING * 15 '                        Name
'----------------------------------------------------------------------------------------
'                                                               PROGRAM CONTROL GLOBAL VARIABLES
REDIM SHARED Char_In(10) AS INTEGER '                           Prior to characterisics input=0, afterwards=1
REDIM SHARED Weap_In(10) AS INTEGER '                           Prior to weapons lists=0, afterwards=1
DIM SHARED ActPC AS INTEGER '                                   Active PC indexer
DIM SHARED MaxPC AS INTEGER '                                   number of PCs in memory
DIM SHARED Scrn_Mode AS INTEGER '                               check state of display full (1) or window (0)
DIM SHARED mouse_x AS INTEGER '                                 for passing mouse x coordinate to other SUBs
DIM SHARED mouse_y AS INTEGER '                                 for passing mouse y coordinate to other SUBs
DIM SHARED offset AS INTEGER '                                  adjustment for larger than display scrolling lists
DIM SHARED offact AS INTEGER '                                  offset for active PC cell
DIM SHARED clr&(0 TO 15) '                                      32 bit equivalent of SCREEN 0 colors array
DIM SHARED chr_img(255) AS LONG '                               handle array for resizeable font
DIM SHARED blink_a& '                                           colors for Click/ name, homeland, occupation; Alter_Color
DIM SHARED blink_b& '                                             "     "    "      "       "        "
'----------------------------------------------------------------------------------------
'                                                               DISPLAY HANDLES
DIM SHARED disp_main AS LONG '                                  handle of main display screen
DIM SHARED back_main AS LONG '                                  handle of background image
DIM SHARED port_cover AS LONG '                                 handle of background snippets
DIM SHARED chs_up AS LONG '                                     handle of choosing screen
DIM SHARED oc_win AS LONG '                                     handle of occupation window
DIM SHARED arrows AS LONG '                                     handle of scrolling arrows
DIM SHARED batsave AS LONG '                                    handle of batch save button image
DIM SHARED batload AS LONG '                                    handle of batch load button image
'----------------------------------------------------------------------------------------
'                                                               DEFINE AND LOAD IMAGE HANDLES
disp_main = _NEWIMAGE(800, 688, 32) '                           define main display screen
back_main = _LOADIMAGE("images\newruneback.png", 32) '          load rune background
port_cover = _COPYIMAGE(back_main) '                            copy of rune background for paper overs
arrows = _LOADIMAGE("images\arrows.png", 32) '                  load scroll up arrows, use SUB RotoZoom2 to flip them to down
batsave = _LOADIMAGE("images\batsave.png", 32) '                load batch save button image
batload = _LOADIMAGE("images\batload.png", 32) '                load batch load button image
oc_win = _NEWIMAGE(480, 400, 32) '                              define occupation screen 60 x 25
chs_up = _NEWIMAGE(320, 275, 32) '                              define choosing screen 40x17
'----------------------------------------------------------------------------------------
FOR Ascii = 0 TO 255 '                                          PETR'S CHARACTER IMAGE LOADER
    chr_img(Ascii) = _NEWIMAGE(8, 16, 32) '                     create image for each ASCII character
    _DEST chr_img(Ascii) '                                      set image destination of ASCII character
    _PRINTSTRING (0, 0), CHR$(Ascii), chr_img(Ascii) '          put ASCII character in image
NEXT Ascii '                                                    now any size ASCII character can be printed
'----------------------------------------------------------------------------------------
'                                                               COLOR DEFINITIONS
RESTORE colors '                                                assign 32 bit color array, reset SCREEN 0 equivalent color data
FOR x = 0 TO 15 '                                               iterate colors 0 thru 15
    READ r% '                                                   get red component
    READ g% '                                                   get green component
    READ b% '                                                   get blue component
    clr&(x) = _RGB32(r%, g%, b%) '                              mix color x into array
NEXT x
'----------------------------------------------------------------------------------------
blink_a& = _RGB32(183, 50, 183) '                               Purple twinkles, because every program needs purple twinkles :)
blink_b& = _RGB32(183, 100, 183)
'----------------------------------------------------------------------------------------
'                                                               VARIABLE TYPE DECLARATIONS
TYPE skill
    ident AS INTEGER '                                          unique ID # of skill
    name AS STRING * 18 '                                       name of skill
    category AS STRING * 4 '                                    category of skill
    value AS INTEGER '                                          percentage of skill
    base_per AS INTEGER '                                       base of skill
    cat_per AS INTEGER '                                        category modifier
    modified AS INTEGER '                                       number of modifications
    exchk AS INTEGER '                                          experience check flag
END TYPE

TYPE characteristic
    name AS STRING * 12 '                                       Full name of characteristic
    abrev AS STRING * 3 '                                       3 letter upper case abbreviation
    dice AS STRING * 5 '                                        dice roll required
    value AS INTEGER '                                          characteristic score
    max AS INTEGER '                                            Maximum attainable non-magical score
    modified AS INTEGER '                                       has characteristic been modified?
END TYPE

TYPE Arms
    ident AS INTEGER '                                          index of weapon
    cate AS STRING * 18 '                                       category
    name AS STRING * 18 '                                       full name of weapon
    bs_per AS INTEGER '                                         base percentage of weapon
    cat_per AS INTEGER '                                        category modifier
    str AS INTEGER '                                            minimum strength required
    dex AS INTEGER '                                            minimum dexterity required
    damage AS STRING * 7 '                                      damage dice to be rolled
    bsr AS INTEGER '                                            base strike rank
    enc AS SINGLE '                                             encumbrance
    hp AS INTEGER '                                             weapon hit points
    hpx AS INTEGER '                                            weapon damaged state
    link AS INTEGER '                                           links to skill number of weapon
    modified AS INTEGER '                                       weapon has been altered by previous experience
    init AS INTEGER '                                           weapon has been initialized if value= 1
    exchk AS INTEGER '                                          experience check flag
    value AS INTEGER '                                          Attack/Parry skill percentage
END TYPE
'----------------------------------------------------------------------------------------
ActPC = 0
MaxPC = 0

'                                                               INITIALIZE FOR NEW CHARACTERS (10 initial slots)
REDIM SHARED PC_skill(115, 10) AS skill '                       Initialize skill array
REDIM SHARED char(7, 10) AS characteristic '                    Initialize characteristic array
REDIM SHARED weap(56, 10) AS Arms '                             Initialize weapons array

FOR A = 1 TO 10 '                                               fill all PC slots with base info
    Initialize_PC_Cell A
NEXT A

RefreshPrompt '                                                 Main loop subroutine
END
'---------------------------------------------------------------End main section and declarations

'                                                               DATA SECTION
'                                                               Skill data
skills:
'READ ORDER PC_skill(x, var).category, PC_skill(x, var).name, PC_skill(x, var).base_per

DATA "agil","Boat",5,"agil","Climb",40,"agil","Dodge",0,"agil","Drive Chariot",5,"agil","Jump",0,"agil","Ride",5,"agil","Swim",15
DATA "comm","Act",5,"comm","Art",5,"comm","Bargain",5,"comm","Charm",15,"comm","Dance",10,"comm","Disguise",5,"comm","Fast Talk",5
DATA "comm","Intimidate",15,"comm","Intrigue",5,"comm","Orate",10,"comm","Sing",10,"comm","Spk Own Language",50,"comm","Spk Trade Talk",0,"comm","Spk Other 2",0
DATA "know","Alchemy",0,"know","Animal Lore",5,"know","Battle",10,"know","Bureaucracy",0,"know","Celestial Lore",5,"know","Cult Lore_________",5,"know","Customs Local",25
DATA "know","Customs Other 1",0,"know","Customs Other 2",0,"know","Elder Race Lore",5,"know","Evaluate",10,"know","Farm",10,"know","First Aid",10,"know","Game",15
DATA "know","Herd",5,"know","Homeland Lore",30,"know","Home Lore Othr 1",0,"know","Home Lore Othr 2",0,"know","Library Use",0,"know","Manage Household",10,"know","Mineral Lore",5
DATA "know","Peaceful Cut",10,"know","Plant Lore",5,"know","Read/Write Own ",0,"know","Read/Write Othr 1",0,"know","Read/Write Othr 2",0,"know","Shiphandling",0,"know","Survival",15
DATA "know","Treat Disease",5,"know","Treat Poison",5,"magi","Meditate",0,"magi","Prepare Corpse",10,"magi","Sense Assassin",0,"magi","Sense Chaos",0,"magi","Spirit Combat",20
DATA "magi","Spirit Dance",0,"magi","Spirit Lore",0,"magi","Spirit Travel",10,"magi","Beastspeech",0,"magi","Worship___________",5,"mani","Conceal",5,"mani","Craft_____________",10
DATA "mani","Craft_____________",10,"mani","Devise",5,"mani","Play Instrument",5,"mani","Sleight",5,"perc","Insight Human",20,"perc","Insight__________",0,"perc","Insight___________",0
DATA "perc","Listen",25,"perc","Scan",25,"perc","Search",25,"perc","Track",5,"stlt","Hide",10,"stlt","Move Quietly",10,"mele","1H Axe",10
DATA "mele","2H Axe",5,"mele","Broadsword",10,"mele","Dagger",15,"natu","Fist",25,"natu","Grapple",25,"mele","1H Hammer",10,"mele","2H Hammer",5
DATA "natu","Kick",15,"mele","Kopis",10,"mele","1H Mace",15,"mele","2H Mace",10,"mele","Pike",15,"mele","Quarterstaff",15,"mele","Rapier",10
DATA "mele","Shortsword",10,"mele","1H Spear",5,"mele","2H Spear",15,"miss","Arbalest",10,"miss","Axe, Thrown",10,"miss","Composite Bow",5,"miss","Crossbow",25
DATA "miss","Dagger, Throwing",5,"miss","Elf Bow",5,"miss","Javelin",10,"miss","Pole Lasso",5,"miss","Rock",15,"miss","Self Bow",5,"miss","Sling",5
DATA "miss","Staff Sling",10,"shld","Large Shield",15,"shld","Medium Shield",15,"shld","Small Shield",15,"magi","Sorcery Spell 1",0,"magi","Sorcery Spell 2",0,"magi","Sorcery Spell 3",0
DATA "magi","Cult Skill +",0,"mele","2H Sword",5

armaments:
'READ ORDER= weap(y, var).cate, weap(y, var).name, weap(y, var).bs_per, weap(y, var).str, weap(y, var).dex,
'            weap(y, var).damage, weap(y, var).bsr, weap(y, var).enc, weap(y, var).hp, weap(y, var).link

DATA "1H Axe","Small Axe",10,7,7,"1D6+1",4,1,6,77,"1H Axe","Battle Axe",10,13,7,"1D8+2",3,2,8,77
DATA "2H Axe","Battle Axe",5,9,7,"1D8+2",3,2,8,78,"2H Axe","Great Axe",5,11,7,"2D6+2",2,2,10,78
DATA "2H Axe","Dagger-Axe",5,13,9,"3D6",1,3,10,78
DATA "Dagger","Dagger",15,0,0,"1D4+2",4,.25,6,80,"Dagger","Parrying Dagger",15,0,0,"1D4+2",4,.33,8,80
DATA "Dagger","Sickle",5,0,0,"1D6+1",3,1,6,80
DATA "1H Sword","Broadsword",10,9,7,"1D8+1",2,1,12,79,"1H Sword","Kopis",10,9,9,"1D8+1",2,1,12,86
DATA "1H Sword","Rapier",10,7,13,"1D6+1",2,1,8,91,"1H Sword","Shortsword",10,0,0,"1D6+1",3,1,12,92
DATA "2H Sword","Greatsword",5,11,13,"2D8",1,2,12,114,"2H Sword","Rhomphaia",5,11,9,"2D6+2",2,2,10,114
DATA "2H Sword","Sickle-sword",5,9,9,"1D10+1",2,1,12,114
DATA "Fist","Heavy Cestus",25,11,0,"1D3+2",4,1,8,81,"Fist","Light Cestus",25,7,0,"1D3+1",4,.5,4,81
DATA "Fist","Claw",25,7,9,"1D4+1",4,1,0,81,"Fist","Fist",25,0,0,"1D3",4,0,0,81
DATA "Grapple","Grapple",25,0,0,"Special",4,0,0,82,"Kick","Kick",15,0,0,"1D6",4,0,0,85
DATA "1H Hammer","War Hammer",10,11,9,"1D6+2",3,1,10,83
DATA "2H Hammer","Great Hammer",5,9,9,"2D6+2",1,3,5,84,"2H Hammer","Maul",10,11,7,"2D8",1,3,12,84
DATA "1H Mace","Heavy Mace",15,13,7,"1D8+2",3,2,10,87,"1H Mace","Light Mace",15,7,7,"1D6+2",3,1,6,87
DATA "1H Mace","Singlestick",15,0,9,"1D6",4,.5,5,87,"1H Mace","Wooden Club",15,7,7,"1D6",4,.5,4,87
DATA "2H Mace","Heavy Mace",10,9,7,"1D8+2",3,2,10,88,"Quarterstaff","Quarterstaff",15,9,9,"1D8",0,2,8,90
DATA "1H Spear","Javelin",10,9,9,"1D6",2,1,8,93,"1H Spear","Short Spear",5,9,7,"1D6+1",2,2,10,93
DATA "1H Spear","Lance",5,9,7,"1D10+1",0,3,10,93
DATA "2H Spear","Pike",15,11,7,"2D6+1",0,3,12,94,"2H Spear","Long Spear",15,9,7,"1D10+1",0,3,10,94
DATA "2H Spear","Short Spear",15,7,7,"1D8+1",1,2,10,94
DATA "Lasso","Pole Lasso",5,9,13,"Special",0,3,4,102
DATA "Bow","Composite Bow",5,13,9,"1D8+1",0,2,7,97,"Bow","Elf Bow",5,9,9,"1D8+1",0,2,6,100
DATA "Bow","Self Bow",5,9,9,"1D6+1",0,2,5,104
DATA "Crossbow","Heavy Crossbow",25,11,7,"2D6+2",0,2,10,98,"Crossbow","Light Crossbow",25,7,7,"2D4+2",0,2,6,98
DATA "Crossbow","Arbalest",10,13,7,"3D6+1",0,3,10,98,"Crossbow","Repeating Crossbow",25,7,7,"2D4+2",0,2,6,98
DATA "Atlatl","Atlatl",5,7,9,"+1D6",0,.5,6,0,"Javelin","Dart",10,0,9,"1D6",0,.5,4,101
DATA "Javelin","Javelin, Thrown",10,9,9,"1D10",0,1,8,101,"Javelin","Short Spear",15,9,7,"1D6+1",0,2,10,101
DATA "Axe, Thrown","Axe, Throwing",10,9,9,"1D6",0,1,6,96,"Dagger, Thrown","Dagger, Throwing",5,0,9,"1D4",0,.25,6,99
DATA "Rock, Thrown","Rock",15,0,0,"1D4",0,.25,0,103
DATA "Sling","Sling",5,0,9,"1D8",0,1,0,105,"Staff Sling","Staff Sling",10,9,9,"1D10",0,2,8,106
DATA "Shield","Large Shield",15,12,0,"1D6",3,3,16,107,"Shield","Medium Shield",15,9,0,"1D4",3,2,12,108
DATA "Shield","Small Shield",15,5,0,"1D3",3,1,8,109

'                                                               Characteristic data
characteristic:
DATA "Strength","STR","3D6"
DATA "Constitution","CON","3D6"
DATA "Size","SIZ","2D6+6"
DATA "Intelligence","INT","2D6+6"
DATA "Power","POW","3D6"
DATA "Dexterity","DEX","3D6"
DATA "Charisma","CHA","3D6"

Weap_1H: '                                                      1 Handed weapons skill list
DATA 9,77,79,80,83,86,87,91,92,93

Weap_2H: '                                                      2 Handed weapons skill list
DATA 7,78,84,88,89,90,94,114

Weap_ALL: '                                                     All weapons skill list
DATA 19,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,114

Weap_MS: '                                                      Missile weapons skill list
DATA 12,95,96,97,98,99,100,101,102,103,104,105,106

Lore_List: '                                                    Lore skill list
DATA 10,23,26,27,31,37,38,39,42,44,58

Craft_List:
DATA 9,"Brewer","Carpenter","Jeweler","Leatherworker","Mason","Potter","Redsmith","Tanner","Weaver"

Home_List:
DATA 10,"Sartar","Esrolia","Grazelands","Prax/Bison","Prax/High Llama","Prax/Impala","Prax/Pol-Joni","Prax/Sable","Lunar Tarsh","Old Tarsh"

Occu_List:
DATA 17," 1  Assistant Shaman"," 2  Bandit"," 3  Chariot Driver (Esrolia, Tarsh, Sartar)"
DATA " 4  Crafter (all except Prax)"," 5  Entertainer","6-9 Farmer (all except Frax)"
DATA "10  Fisher (Esrolia, Tarsh, Sartar)","11  Healer","12  Herder"
DATA "13  Hunter (Grazelands, Old Tarsh, Prax, Sartar)","14  Merchant","15  Noble"
DATA "16  Philosopher (Esrolia, Sartar, Lunar Tarsh)","17  Priest","18  Scribe (Prax only in Pavis)"
DATA "19  Thief (Esrolia, Sartar, Lunar Tarsh)","20  Warrior"

Warrior_List:
DATA 4,"Heavy Infantry","Light Infantry","Heavy Cavalry","Light Cavalry"

HvyInf_List:
DATA 2,"1-4  1H weapon & large shield","5-6  2H weapon"

LtInf_List:
DATA 4,"1-2  Sling, 1H weapon (choose), Small shield","3-4  Javelin, 1H weapon (choose), Medium shield"
DATA "5    Self Bow, 1H weapon (choose), Medium shield","6    Throwing Axe, 1H weapon (choose), Medium shield"

HvyCav_List:
DATA 3,"1    Composite Bow, Lance, 1H weapon (choose)","2-5  Lance, 1H weapon (choose), Medium shield"
DATA "6    Javelin, Lance, 1H weapon (choose)"

LtCav_List:
DATA 5,"1    Composite Bow, 1H weapon (choose), Small shield","2-3  Composite Bow, Lance, 1H weapon (choose)"
DATA "4    Javelin, 1H weapon (choose), Medium shield","5    Lance, 1H weapon (choose), Small shield"
DATA "6    Lance, 1H weapon (choose), Medium shield"

colors:
'                                                               colors 0-4
DATA 0,0,0,0,0,168,0,168,0,0,168,168,168,0,0
'                                                               colors 5-9
DATA 168,0,168,168,84,0,168,168,168,84,84,84,84,84,252
'                                                               colors 10-14
DATA 84,252,84,84,252,252,252,84,84,252,84,252,252,252,84
'                                                               color 15
DATA 252,252,252


'--------------------------------------------------------------End DATA section

SUB Adjust_Mod (var1 AS INTEGER, var2 AS INTEGER)

    '-------------------------ALGORITHM--------------------------------------------------CLEARED
    ' SUB: Adjust_Mod
    '
    ' Purpose:
    ' Adjust singular skill value and category modifier after characteristic change
    ' Use in skill recalculation loops, primarily called from Recalc_Skills
    '
    ' Passed variables:
    ' var1= index of skill to be altered
    ' var2= updated category modifier of skill to be altered
    '
    '------------------------------------------------------------------------------------

    IF PC_skill(var1, ActPC).cat_per <> var2 THEN
        IF PC_skill(var1, ActPC).base_per = 0 AND PC_skill(var1, ActPC).modified = 0 THEN
            'No changes in value for untrained, zero base skills.
        ELSEIF PC_skill(var1, ActPC).base_per = 0 AND PC_skill(var1, ActPC).modified > 0 THEN
            change = var2 - PC_skill(var1, ActPC).cat_per
            PC_skill(var1, ActPC).value = PC_skill(var1, ActPC).value + change ' change the skill but...
            IF change < 0 AND PC_skill(var1, ActPC).value < 5 THEN ' Don't lower a trained skill below 5%
                PC_skill(var1, ActPC).value = 5
            END IF
        ELSE
            change = var2 - PC_skill(var1, ActPC).cat_per
            PC_skill(var1, ActPC).value = PC_skill(var1, ActPC).value + change
            IF PC_skill(var1, ActPC).value < 5 AND PC_skill(var1, ActPC).base_per > 0 THEN
                PC_skill(var1, ActPC).value = 5
            END IF
        END IF
        PC_skill(var1, ActPC).cat_per = var2
    END IF

END SUB 'Adjust_Mod


SUB Alter_Color (var1 AS STRING, ypos AS INTEGER, xpos AS INTEGER)

    '-------------------------DISPLAY----------------------------------------------------CLEARED
    ' SUB: Alter_Color
    '
    ' Purpose:
    ' Displays name, homeland & occupation strings of active character. Displays a
    ' mouse click locator message in alternating colors prior to the entry of that
    ' information.
    '
    ' Passed Variables:
    ' var1 sends name, homeland or occupation string involved in call
    ' altC sends color value of click locator message
    ' normC sends color value of involved data once set
    ' ypos sends row position of value involved in call
    ' xpos sends column position of value involved in call
    '
    '------------------------------------------------------------------------------------

    IF LEFT$(var1, 6) = "Click/" THEN
        LOCATE ypos, xpos
        FOR a = 1 TO LEN(var1)
            IF a MOD 2 = 0 THEN
                COLOR blink_a&
            ELSE
                COLOR blink_b&
            END IF
            PRINT MID$(var1, a, 1);
        NEXT a
    ELSE
        COLOR clr&(14)
        LOCATE ypos, xpos
        PRINT var1
    END IF

END SUB 'Alter_Color


SUB Attributes (var AS INTEGER)

    '-------------------------ALGORITHM--------------------------------------------------CLEARED
    ' SUB: Attributes
    '
    ' Purpose:
    ' Calculate the character's attributes based upon it's characteristics.
    '
    ' Passed Variables:
    ' var sends PC index, usually ActPC but occasionally alternate index such as
    ' that sent by removal routine.
    '
    '------------------------------------------------------------------------------------

    magpoints(var) = char(5, var).value '                       Magic Points

    x1 = Bonus(1, 3, var): x2 = Bonus(2, 5, var) '              Hit Points
    hitpoints(var) = char(2, var).value + x1 + x2

    SELECT CASE hitpoints(var) '                                Location hit points
        CASE 1 TO 6
            x! = 0
        CASE IS > 6
            x! = (hitpoints(var) - 6) / 3
            IF x! <> INT(x!) THEN x! = INT(x! + 1)
    END SELECT
    IF char(2, var).value = 0 THEN '                            CON-0 PC has no hit points
        LegHP(var) = 0
        AbdmHP(var) = 0
        ChstHP(var) = 0
        ArmHP(var) = 0
        HeadHP(var) = 0
    ELSE
        LegHP(var) = 2 + x
        AbdmHP(var) = 2 + x
        ChstHP(var) = 3 + x
        ArmHP(var) = 1 + x
        HeadHP(var) = 2 + x
    END IF

    SELECT CASE char(6, var).value '                            Dex SR
        CASE 1 TO 5
            dexsr(var) = 5
        CASE 6 TO 8
            dexsr(var) = 4
        CASE 9 TO 12
            dexsr(var) = 3
        CASE 13 TO 15
            dexsr(var) = 2
        CASE 16 TO 18
            dexsr(var) = 1
        CASE IS > 18
            dexsr(var) = 0
    END SELECT

    SELECT CASE char(3, var).value '                            Siz SR
        CASE 1 TO 6
            sizsr(var) = 3
        CASE 7 TO 14
            sizsr(var) = 2
        CASE 15 TO 21
            sizsr(var) = 1
        CASE IS > 21
            sizsr(var) = 0
    END SELECT

    basesrm(var) = dexsr(var) + sizsr(var) '                    Base SRM

    x! = char(2, var).value / 6 '                               Healing Rate
    IF x! <> INT(x!) THEN
        x! = INT(x! + 1)
    END IF
    healrate(var) = x!

    x = char(1, var).value + char(3, var).value '               Damage Bonus
    SELECT CASE x
        CASE IS < 13
            dambonus(var) = "-1D4"
        CASE 13 TO 24
            dambonus(var) = "-"
        CASE 25 TO 32
            dambonus(var) = "+1D4"
        CASE 33 TO 40
            dambonus(var) = "+1D6"
        CASE 41 TO 56
            dambonus(var) = "+2D6"
        CASE IS > 56
            var! = (x - 56) / 16
            IF var! <> INT(var!) THEN var! = INT(var! + 1)
            var! = var! + 2
            dambonus(var) = "+" + LTRIM$(STR$(var!)) + "D6"
    END SELECT

    x = char(5, var).value + char(7, var).value '               Spirit Combat Damage
    SELECT CASE x
        CASE IS < 13
            sprtcmbtdam(var) = "1D3"
        CASE 13 TO 24
            sprtcmbtdam(var) = "1D6"
        CASE 25 TO 32
            sprtcmbtdam(var) = "1D6+1"
        CASE 33 TO 40
            sprtcmbtdam(var) = "1D6+3"
        CASE 41 TO 56
            sprtcmbtdam(var) = "2D6+3"
        CASE IS > 56
            var! = (x - 56) / 16
            IF var! <> INT(var!) THEN var! = INT(var! + 1)
            var2 = var! + 2: var3 = var! + 3
            sprtcmbtdam(var) = LTRIM$(STR$(var2)) + "D6+" + LTRIM$(STR$(var3))
    END SELECT

    x! = (char(1, var).value + char(2, var).value) / 2 '        Maximum ENC
    IF x! <> INT(x!) THEN x! = INT(x! + 1)
    IF x! > char(1, var).value THEN x! = char(1, var).value
    maxenc(var) = x!

    Dodge_Jump

END SUB 'Attributes


SUB Basic_Skills

    '-------------------------ALGORITHM--------------------------------------------------CLEARED
    ' SUB: Basic_Skills
    '
    ' Purpose:
    ' Initialize the active PC's starting skills and weapons after characterisitic input.
    '
    ' Passed Variables:
    ' None
    '
    '------------------------------------------------------------------------------------

    FOR x = 1 TO UBOUND(PC_skill, 1)
        SELECT CASE PC_skill(x, ActPC).category
            CASE IS = "agil"
                PC_skill(x, ActPC).cat_per = Agil(ActPC)
            CASE IS = "comm"
                PC_skill(x, ActPC).cat_per = Communi(ActPC)
            CASE IS = "know"
                PC_skill(x, ActPC).cat_per = Know(ActPC)
            CASE IS = "magi"
                PC_skill(x, ActPC).cat_per = Magic(ActPC)
            CASE IS = "mani"
                PC_skill(x, ActPC).cat_per = Manip(ActPC)
            CASE IS = "perc"
                PC_skill(x, ActPC).cat_per = Percep(ActPC)
            CASE IS = "stlt"
                PC_skill(x, ActPC).cat_per = Stealth(ActPC)
            CASE IS = "mele"
                PC_skill(x, ActPC).cat_per = Melee(ActPC)
            CASE IS = "miss"
                PC_skill(x, ActPC).cat_per = Missile(ActPC)
            CASE IS = "shld"
                PC_skill(x, ActPC).cat_per = Shield(ActPC)
            CASE IS = "natu"
                PC_skill(x, ActPC).cat_per = Natur(ActPC)
        END SELECT
        IF PC_skill(x, ActPC).base_per = 0 THEN
            PC_skill(x, ActPC).value = 0
        ELSE
            y = PC_skill(x, ActPC).base_per + PC_skill(x, ActPC).cat_per
            IF PC_skill(x, ActPC).value < y THEN
                PC_skill(x, ActPC).value = PC_skill(x, ActPC).base_per + PC_skill(x, ActPC).cat_per
            END IF
            IF PC_skill(x, ActPC).value < 0 THEN
                PC_skill(x, ActPC).value = 0
            END IF
        END IF
    NEXT x
    FOR x = 1 TO 56
        weap(x, ActPC).cat_per = Manip(ActPC)
        weap(x, ActPC).value = weap(x, ActPC).bs_per + Manip(ActPC) 'set all to base ability
        IF weap(x, ActPC).value < 5 THEN
            weap(x, ActPC).value = 5 '                               minimum is 5%
        END IF
    NEXT x
    Dodge_Jump

END SUB 'Basic_Skills


SUB Batch_Load

    '------------------------------------------------------------------------------------
    ' SUB: Batch_Load
    '
    ' Purpose:
    ' Load all PCs present in named .btc file.
    '
    ' Passed parameters:
    ' None
    '
    '------------------------------------------------------------------------------------

    Choosing_Screen
    LOCATE 1, 15
    PRINT "BATCH LOAD"
    PRINT
    INPUT "Input batch name: ", btcname$
    btcname$ = btcname$ + ".btc"
    OPEN btcname$ FOR INPUT AS #5
    DO WHILE NOT EOF(5)
        x = x + 1
        IF x > 10 THEN '                                        MaxPC or 10? MaxPC may advance REDIMS beyond functional ubound
            Expand_PC_Count
        END IF
        INPUT #5, PCname(x)
        Load_PC "B", x
        MaxPC = x
        Attributes ActPC '                                      compute loaded PCs attributes
        Category_Mods ActPC '                                   compute loaded PCs category modifiers
    LOOP
    CLOSE #5

END SUB 'Batch_Load


SUB Batch_Save

    '------------------------------------------------------------------------------------
    ' SUB: Batch_Save
    '
    ' Purpose:
    ' Save all PCs present sequentially, constructing .btc file to control future
    ' batch loading call.
    '
    ' Passed parameters:
    ' None
    '
    '------------------------------------------------------------------------------------


    Choosing_Screen
    t = ActPC '                                                 Save previous state
    LOCATE 1, 15
    PRINT "BATCH SAVE"
    PRINT
    INPUT "Name for the batch: ", btcname$
    btcname$ = btcname$ + ".btc"
    OPEN btcname$ FOR OUTPUT AS #5
    FOR x = 1 TO MaxPC
        ActPC = x
        WRITE #5, PCname(x)
        Save_PC
    NEXT x
    CLOSE #5
    ActPC = t '                                                 Return to previous state

END SUB 'Batch_Save


FUNCTION Bonus (var1 AS INTEGER, stat AS INTEGER, PCin AS INTEGER)

    '-------------------------ALGORITHM--------------------------------------------------CLEARED
    ' FUNCTION: Bonus
    '
    ' Purpose:
    ' Returns the multiplier for characteristic based attributes.
    ' Use staight for hit points and multiply by 5 for skill category modifiers.
    '
    ' Passed Variables:
    ' var1 passes the following: 1=primary 2=secondary -1=negative primary
    ' -2=negative secondary
    ' stat passes the characteristic index in question
    ' PCin passes the PC index usually ActPC but also a loop control from
    ' Edit 4 removal routine
    '
    '------------------------------------------------------------------------------------

    var2! = char(stat, PCin).value / 4
    IF var2! <> INT(var2!) THEN
        var2! = INT(var2! + 1)
    END IF
    var2! = var2! - 3 '                                         var2! is now correct for a primary positive characteristic
    IF var2! <> 0 THEN
        SELECT CASE var1
            CASE IS = 1
                '                                               no changes required for primary/positive var2!
            CASE IS = -1
                var2! = -1 * var2! '                            var2! is now correct for a primary negative
            CASE IS = 2
                IF var2! < 0 THEN
                    var2! = var2! + 1 '                         adjust var2! to characteristic 1-4 range/ positive
                END IF
                IF var2! > 0 THEN
                    var2! = var2! - 1 '                         adjust var2! to characteristic >17 range/ positive
                END IF
            CASE IS = -2
                IF var2! < 0 THEN
                    var2! = var2! + 1 '                         adjust var2! to characteristic 1-4 range/ negative
                END IF
                IF var2! > 0 THEN
                    var2! = var2! - 1 '                         adjust var2! to characteristic >17 range/ negative
                END IF
                var2! = var2! * -1
        END SELECT
    END IF
    Bonus = var2! '                                             return result

END FUNCTION 'Bonus


SUB Category_Mods (var AS INTEGER)

    '-------------------------ALGORITHM--------------------------------------------------CLEARED
    '
    ' SUB: Category_Mods
    '
    ' Purpose:
    ' Calculates skills category modifiers. Calling on SUB Bonus for raw data.
    '
    ' Passed Variables:
    ' var sends PC index- usually ActPC, occasionally a loop controlled variable
    ' as in SUB Edit 4 PC removal routine
    '
    '------------------------------------------------------------------------------------

    x1 = Bonus(2, 1, var) * 5 '                                 Agility
    x2 = Bonus(-2, 3, var) * 5
    x3 = Bonus(1, 6, var) * 5
    x4 = Bonus(2, 5, var) * 5
    Agil(var) = x1 + x2 + x3 + x4

    x1 = Bonus(2, 4, var) * 5 '                                 Communication
    x2 = Bonus(2, 5, var) * 5
    x3 = Bonus(1, 7, var) * 5
    Communi(var) = x1 + x2 + x3

    x1 = Bonus(1, 4, var) * 5 '                                 Knowledge
    x2 = Bonus(2, 5, var) * 5
    Know(var) = x1 + x2

    x1 = Bonus(1, 5, var) * 5 '                                 Magic
    x2 = Bonus(2, 7, var) * 5
    Magic(var) = x1 + x2

    x1 = Bonus(2, 1, var) * 5 '                                 Manipulation
    x2 = Bonus(2, 5, var) * 5
    x3 = Bonus(1, 6, var) * 5
    x4 = Bonus(1, 4, var) * 5
    Manip(var) = x1 + x2 + x3 + x4

    x1 = Bonus(1, 4, var) * 5 '                                 Perception
    x2 = Bonus(2, 5, var) * 5
    Percep(var) = x1 + x2

    x1 = Bonus(-1, 3, var) * 5 '                                Stealth
    x2 = Bonus(1, 6, var) * 5
    x3 = Bonus(1, 4, var) * 5
    x4 = Bonus(-2, 5, var) * 5
    Stealth(var) = x1 + x2 + x3 + x4

    Melee(var) = Manip(var) '                                   Melee

    Missile(var) = Manip(var) '                                 Missile

    Shield(var) = Manip(var) '                                  Shield

    Natur(var) = Manip(var) '                                   Natural

END SUB 'Category_Mods


SUB Category_Pull (var AS Arms)

    '-------------------------ALGORITHM--------------------------------------------------CLEARED
    ' SUB: Category_Pull
    '
    ' Purpose:
    ' Checks all weapons to see if they are in the same category as the tested weapon,
    ' then sets all in the category to half that weapons value if they are lower.
    ' Also sets the value of the related skill if tested weapon is the highest.
    '
    ' Passed Variables:
    ' var sends weapon element to test for category increases
    '
    '------------------------------------------------------------------------------------

    DIM temp_arm(4) AS Arms
    count = 0
    '                                                           build sorting list
    FOR x = 1 TO 56
        IF var.cate = weap(x, ActPC).cate THEN
            count = count + 1
            temp_arm(count) = weap(x, ActPC)
        END IF
    NEXT x
    '                                                           sort the list in ascending order
    FOR y = 1 TO count - 1
        FOR z = y + 1 TO count
            IF temp_arm(y).value > temp_arm(z).value THEN
                SWAP temp_arm(y), temp_arm(z)
            END IF
        NEXT z
    NEXT y
    '                                                           pull the lesser skills to 1/2 skill minimum and link to PC_skill
    FOR w = 1 TO count - 1
        IF temp_arm(w).value < temp_arm(count).value / 2 THEN
            temp_arm(w).value = temp_arm(count).value / 2
            weap(temp_arm(w).ident, ActPC).value = temp_arm(w).value
            PC_skill(temp_arm(w).link, ActPC).value = temp_arm(w).value
        END IF
    NEXT w
    PC_skill(temp_arm(count).link, ActPC).value = temp_arm(count).value

END SUB 'Category_Pull


SUB Char_Click (var AS INTEGER)

    '-------------------------QUERY------------------------------------------------------CLEARED
    ' SUB: Char_Click
    '
    ' Purpose:
    ' Conducts input of characteristic editing at the display position of the edited
    ' element upon mouse click on that position. Conducts recalculation of all data
    ' after the change. Rejects null results.
    '
    ' Passed Variables:
    ' var sends row position (and by extension index value) of characteristic
    '
    '------------------------------------------------------------------------------------

    _PRINTMODE _FILLBACKGROUND
    LOCATE var, 5
    COLOR clr&(14), clr&(1)
    PRINT char(var, ActPC).value
    LOCATE var, 4
    INPUT "  ", temp%
    IF temp% <> 0 THEN
        char(var, ActPC).value = temp%
    END IF
    RefreshScreen 1
    Attributes ActPC
    Category_Mods ActPC
    Recalc_Skills

END SUB 'Char_Click


SUB Characteristic_In

    '-------------------------ALGORITHM/DISPLAY------------------------------------------CLEARED
    '
    ' SUB: Characteristic_In
    '
    ' Purpose:
    ' Displays characteristic name, required dice and accepts input of characteristic
    ' Sets species maximums for human characters.
    '
    ' Passed Variables:
    ' None
    '
    '------------------------------------------------------------------------------------

    '                                                           PC characteristic inputs
    head$ = "INPUT CHARACTERISTICS"
    FOR x = 1 TO 7 '                                            Do the inputs
        Choosing_Screen
        LOCATE 1, 9
        PRINT head$
        LOCATE 8, 1
        PRINT "Roll "; char(x, ActPC).dice; " for "; char(x, ActPC).name;
        INPUT char(x, ActPC).value
    NEXT x

    char(1, ActPC).max = 21 '                                   set characteristic maximums
    char(2, ActPC).max = 21
    char(3, ActPC).max = char(3, ActPC).value
    char(4, ActPC).max = char(4, ActPC).value
    char(5, ActPC).max = 21
    Max_Dex
    char(7, ActPC).max = 21
    Char_In(ActPC) = 1 '                                        Characteristics have been entered flag
    MaxPC = MaxPC + 1
    Attributes ActPC '                                          Determine PC attributes (see appropriate SUB for details)
    Category_Mods ActPC '                                       Determine skills category modifiers (see appropriate SUB for details)
    Basic_Skills '                                              Determine starting skills and weapons (see appropriate SUB for details)

END SUB 'Characteristic_In


FUNCTION Choose_Unit_Arms

    '------------------------------------------------------------------------------------CLEARED
    ' FUNCTION: Choose_Unit_Arms
    '
    ' Purpose:
    ' Load unit arms list determined in calling SUB, display and accept mouseclick
    ' choice from the list. Used for warrior occupations.
    '
    ' Passed parameters:
    ' None passed but calling sub should RESTORE appropriate data list before calling
    '
    '------------------------------------------------------------------------------------

    READ last% '                                                Read index in data restored before call
    DIM temp$(last%) '                                          dimension text array by that index
    FOR x = 1 TO last% '                                        load array data
        READ temp$(x)
    NEXT x

    Occupation_Screen
    LOCATE 1, 15
    COLOR clr&(14)
    PRINT "ROLL D6 OR CHOOSE UNIT WEAPONS"
    COLOR clr&(15)
    DO
        FOR x = 1 TO last%
            LOCATE 2 + x, 5
            IF INT((mouse_y - 15) / 16) = x THEN
                IF mouse_x > 31 AND mouse_x < 440 THEN COLOR clr&(12)
            END IF
            PRINT temp$(x)
            COLOR clr&(15)
        NEXT x

        Mouse_Loop 0, 0, 0
        cho% = Mouse_Point%(2, last%, 31, 440)
        _LIMIT 50
    LOOP UNTIL cho% <> 0
    _DELAY .25
    Choose_Unit_Arms = cho%

END FUNCTION 'Choose_Unit_Arms


SUB Choose_Up (var1 AS INTEGER, var2 AS INTEGER, var3 AS INTEGER, var4 AS INTEGER)

    '-------------------------QUERY/DISPLAY----------------------------------------------CLEARED
    ' SUB: Choose_Up
    '
    ' Purpose:
    ' Accepts a mouse choice of 2 to 3 skills and increments choice by a determined
    ' amount.
    '
    ' Passed Variables:
    ' var1 thru var3 sends skills for choice
    ' var4 sends amount to increment to the choice
    '
    '------------------------------------------------------------------------------------

    IF var3 = 0 THEN
        last% = 2
        DIM temp%(last%)
        temp%(1) = var1: temp%(2) = var2
    ELSE
        last% = 3
        DIM temp%(last%)
        temp%(1) = var1: temp%(2) = var2: temp%(3) = var3
    END IF
    redo:
    Choosing_Screen '                                           40 x 17
    COLOR clr&(14)
    LOCATE 1, 14
    PRINT "CHOOSE SKILL"
    DO
        FOR x = 1 TO last%
            LOCATE 2 + x, 6
            IF INT((mouse_y - 16) / 16) = x AND mouse_x > 48 AND mouse_x < 264 THEN m_over = 1
            Color_Test LTRIM$(STR$(x)), temp%(x), m_over
            m_over = 0
        NEXT x

        Mouse_Loop 0, 0, 0
        cho% = Mouse_Point%(2, last%, 48, 264)

        _LIMIT 50
    LOOP UNTIL cho% <> 0
    _DELAY .25

    SELECT CASE cho%
        CASE IS = 1
            Skill_Up var1, var4
        CASE IS = 2
            Skill_Up var2, var4
        CASE IS = 3
            Skill_Up var3, var4
        CASE ELSE
            GOTO redo
    END SELECT

END SUB 'Choose_Up


SUB Choosing_Screen

    '-------------------------DISPLAY----------------------------------------------------CLEARED
    ' SUB: Choosing_Screen
    '
    ' Purpose:
    ' Sets parameters for and displays general pupose data view ports
    '
    ' Passed Variables:
    ' upy sends upper row limit of view port
    ' lowy sends lower row limit of view port
    ' text sends default color of screen text
    ' back sends default color of screen background
    '
    '------------------------------------------------------------------------------------

    SCREEN chs_up
    _DEST chs_up
    CLS
    _PUTIMAGE , back_main
    _PRINTMODE _KEEPBACKGROUND

END SUB 'Choosing_Screen


SUB Color_Test (var1 AS STRING, var2 AS INTEGER, var3 AS INTEGER)

    '-------------------------DISPLAY----------------------------------------------------CLEARED
    ' SUB: Color_Test
    '
    ' Purpose:
    ' Display singular skills for choice screens, changing display colors for mouse
    ' over situations.
    '
    ' Passed Variables:
    ' var1 sends alpha-numeric string representation of skill being displayed
    '      purpose for future hot key assignments
    ' var2 sends index of skill being displayed
    ' var3 sends index of color change on mouse over
    '
    '------------------------------------------------------------------------------------

    IF PC_skill(var2, ActPC).modified > 0 THEN
        COLOR clr&(15)
    END IF
    IF var3 = 1 THEN
        COLOR clr&(12)
    END IF
    PRINT var1; "-> "; PC_skill(var2, ActPC).name; " ("; PC_skill(var2, ActPC).value; ")"
    COLOR clr&(15)

END SUB 'Color_Test


SUB Comments

    '------------------------------------------------------------------------------------CLEARED
    ' SUB: Comments
    '
    ' Purpose:
    ' Contains non-executables, program notes & debug packages
    '
    ' Passed Variables:
    ' None
    '
    '------------------------------------------------------------------------------------

    ' VERSION HISTORY
    ' Version 1.0.1 adds multiple character saving, loading,
    ' switching and editing. Working name changed to PCmulti.
    '
    ' Version 1.0.2 adds mouse support for main module,
    ' skill and characteristics editing.
    '
    ' Version 1.0.3 completes mouse support for all
    ' necessary SUBs.
    '
    ' Version 1.0.4 adds experience check capability, but
    ' requires PC file conversion utility to upgrade PCs
    ' created under earlier versions.
    '
    ' Version 1.0.5 includes exchk flags in main display.
    '
    ' Bug fix (1.0.5.a) corrects characteristic file (.pc2)
    ' which was far too large for the data contained. File
    ' conversion required to maintain compatibility.
    '
    ' Version 1.0.6 (gamma) adds weapon data to the character.
    '
    ' Version 1.1.0 "PC Minder" fixes major issues with Init_Weapons SUB
    ' and includes a complete rewrite of Category_Pull SUB
    ' in addition to numerous small bugs and instabilities.
    ' Array structure changes cause compatibility issues.
    ' Maybe this one is ready for serious beta testing....
    '
    ' Version 1.1.1 prevents Homeland or Occupation prior to
    ' entering characteristics, which caused base reset of skills.
    ' Also eliminates possibility of DEX changes not reflected in Dodge
    ' and Jump abilities that have had low level experience increases.
    ' Also adds a PC deletion routine to SUB Edit. Removes annoyance of
    ' flashing strength/dexterity penalty indicators. Fixes bug that
    ' prevents program from updating version markers in .pc1 file.
    ' Fixed zero weapon skills that result from loading older PCs.
    ' Fixed subscript out of range error caused by PC overflow.
    ' No compatibiliy changes.
    '
    ' Version 1.1.2 redesigns multidimensional arrays to allow
    ' REDIM _PRESERVE without data corruption. Incorporates
    ' _FILEEXISTS in Load_PC to prevent file not found runtime
    ' errors. Add program icon. Display_Weapons altered to
    ' to get rid of display bug associated with exceeding 10
    ' modified weapon skills. Installed rounding functions to
    ' align the C/S/F popup with the RQG rules Ability Results
    ' Table.
    '
    ' Version 2.0.0 converts display routines to 32 bit color
    ' graphics. Appends the 2H Sword choice for heavy infantry
    ' PCs. Batch load and save installed. New character on mouse
    ' click "subscript out of range" bug when more than 10 PCs
    ' are loaded fixed. Cleaned up "last" PC removal housekeeping.
    ' Removed "Active" menu choice and install PC choice list to
    ' main display lower right. Removed redundant legacy edit
    ' choices. Fixed mouse alignment bug in Init_Weapons.


    '*****************************
    ''debug code: has weapon been here?
    ''Place code in places that Weap skill may pass through
    ''name alteration verifies passage
    'weap(x, ActPC).name = MID$(weap(x, ActPC).name, 1, 16) + "@@"
    ''****************************

    ''debug code
    ''display nested loop position of specified weapon skill
    'IF weap(55, ActPC).value = 25 THEN
    '    Choosing_Screen 9, 40, 0, 3
    '    PRINT "skill loop= "; loop0
    '    PRINT "weapon loop1= "; loop1
    '    SLEEP
    'END IF
    ''**************

    '"There are two ways of constructing a software design:
    'one way is to make it so simple that there are obviously no deficiencies,
    'and the other way is to make it so complicated that there are no obvious deficiencies.
    'The first method is far more difficult." -- Tony Hoare

    'I think this one might qualify as the later...;)

END SUB 'Comments


SUB Craft_Choice (var1 AS INTEGER, var2 AS STRING)

    '-------------------------QUERY/DISPLAY----------------------------------------------CLEARED
    ' SUB: Craft_Choice
    '
    ' Purpose:
    ' Conduct the choice of craft skills, assigning specific names to skills #63 & #64
    '
    ' Passed Variables:
    ' var1 sends increment to apply to resulting choice
    ' var2 sends "primary"/"secondary"/ etc. classifications of choices.
    '
    '------------------------------------------------------------------------------------

    RESTORE Craft_List
    READ last%
    DIM temp$(last%)
    FOR x = 1 TO last%
        READ temp$(x)
    NEXT x

    cho% = 0
    Choosing_Screen '                                           40 x 17
    COLOR clr&(14)
    LOCATE 1, 8
    PRINT "Choose "; var2; " craft"
    COLOR clr&(15)
    DO
        redocraft:
        'print list
        FOR x = 1 TO last%
            LOCATE x + 2, 10
            IF INT((mouse_y - 15) / 16) = x AND mouse_x > 120 AND mouse_x < 224 THEN
                COLOR clr&(12)
            END IF
            PRINT x; "-> "; temp$(x)
            COLOR clr&(15)
        NEXT x

        Mouse_Loop 0, 0, 0
        cho% = Mouse_Point(2, last%, 120, 224)

        _LIMIT 30
    LOOP UNTIL cho% <> 0
    _DELAY .25

    IF var2 = "primary" OR var2 = "" THEN '                     assign name to skill
        x = 63
    END IF
    IF var2 = "secondary" THEN
        x = 64
    END IF
    PC_skill(x, ActPC).name = temp$(cho%)

    Skill_Up x, var1 '                                          increment skill

END SUB 'Craft_Choice


SUB Display_Skills

    '-----------------------------------------------------------------------------------
    ' SUB: Display_Skills
    '
    ' Purpose:
    ' Called from RefreshScreen, this SUB sorts out just enough untrained and/or
    ' low level skills for the remainder to fit in the display space. It then displays
    ' that condensed list.
    '
    ' Passed parameters:
    ' None
    '-----------------------------------------------------------------------------------

    '                                                           Skill window
    lowcount% = 0 '                                             Eliminate low value and/or unmodified skills to fit window
    lowrow% = 0
    lowend% = -1
    DO
        count% = 0
        lowcount% = 0
        lowend% = lowend% + 1
        FOR a = 1 TO UBOUND(PC_skill, 1)
            IF PC_skill(a, ActPC).value > lowend% OR PC_skill(a, ActPC).modified > 0 OR PC_skill(a, ActPC).exchk = 1 THEN
                count% = count% + 1
            ELSE
                lowcount% = lowcount% + 1
            END IF
        NEXT a
    LOOP UNTIL count% < 90

    row% = 10 '                                                 Print condensed skill list
    col% = 1
    y% = 1
    COLOR clr&(10)
    FOR x = 1 TO UBOUND(PC_skill, 1)
        LOCATE row%, col%
        IF PC_skill(y%, ActPC).value > lowend% OR PC_skill(y%, ActPC).modified > 0 OR PC_skill(y%, ActPC).exchk = 1 THEN
            IF PC_skill(y%, ActPC).modified <> 0 THEN COLOR clr&(15)
            PRINT PC_skill(y%, ActPC).name; USING "###"; PC_skill(y%, ActPC).value;
            IF PC_skill(y%, ActPC).exchk = 1 THEN
                PRINT " *";
            END IF
            COLOR clr&(10)
            row% = row% + 1
        END IF
        IF row% > 10 + INT(count% / 3) THEN '                   test was =39 previously and mostly worked
            lowrow% = 10 + INT(count% / 3)
            col% = col% + 27
            row% = 10
        END IF
        y% = y% + 1
    NEXT x
    IF lowrow% < 36 AND Char_In(ActPC) > 0 THEN
        LOCATE lowrow% + 2, 1: PRINT lowcount%; "additional skills "; lowend%; "% or less not shown."
    END IF

END SUB 'Display_Skills


SUB Display_Weapons

    '-------------------------DISPLAY----------------------------------------------------CLEARED
    ' SUB: Display_Weapons
    '
    ' Purpose:
    ' Displays improved character weapons and scrolling complete weapon list. Shows
    ' proficiencies in the former, while displaying all possible usage in the later.
    ' Allows for advanced editing of experience checks, name, skill and hit point values.
    '
    ' Passed Variables:
    ' None
    '
    '------------------------------------------------------------------------------------

    offset = 0
    DO
        COLOR clr&(14)
        LOCATE 40, 1
        PRINT "hover and left click to edit, any key or right click to exit,"
        LOCATE 41, 1
        PRINT "mouse wheel scrolls through lower list";

        'Set heading
        LOCATE 9, 1
        COLOR clr&(3)
        '      1   5                  24  28   33      41   46  50               67      75<-tab positions
        PRINT "exp Weapon             SR  -%-  Damage  Enc  HP  STR/DEX          C/S/F   ID"


        count% = 0 '                                            CONDENSE WEAPON LIST FOR UPPER DISPLAY
        FOR a = 1 TO UBOUND(weap, 1) '                          determine number of experienced weapons
            IF weap(a, ActPC).modified > 0 THEN
                count% = count% + 1
            END IF
        NEXT a

        y% = 0 '                                                ASSIGN CONDENSED LIST TO TEMPORARY VARIABLE al()
        FOR x = 1 TO UBOUND(weap, 1)
            IF weap(x, ActPC).modified > 0 THEN
                y% = y% + 1
                REDIM _PRESERVE al(y%) AS Arms
                al(y%) = weap(x, ActPC)
            END IF
        NEXT x

        row% = 9 '                                              PRINT CONDENSED LIST OF TRAINED ARMS
        FOR x = 1 TO count%
            row% = row% + 1
            Print_Arms row%, al(x), clr&(15), 6
        NEXT x


        '                                                       SET UP ALL ARMS SCREEN
        ytop = 10 + count%
        max_offset = 56 - (39 - ytop)
        bottom = 38
        FOR x = ytop TO bottom
            Print_Arms x + 1, weap(x + 1 - ytop + offset, ActPC), clr&(7), 0 'x + offset falls one short of 56
        NEXT x

        Mouse_Loop 1, max_offset, offset
        '                                                       PROCESS MOUSE CLICKS
        mouse_in = _MOUSEBUTTON(1) '                            left click of mouse
        mouse_out = _MOUSEBUTTON(2) '                           right click of mouse
        IF mouse_out = -1 THEN '                                If right mouse button click
            _AUTODISPLAY '                                      cancel _DISPLAY before exiting weapons display
            EXIT SUB '                                          exit weapons display
        END IF
        IF mouse_in = -1 THEN '                                 If left mouse button click
            _DELAY .2
            IF mouse_y > 143 AND mouse_y <= ytop * 16 - 1 THEN 'If mouse within trained weapons field
                '                                               main weapons routines referencing from al(y%) printed list
                '                                               use al(10 thru count%).ident to refer to weap(?, ActPC)
                '                                               syntax is weap(al(INT(mouse_y / 16) - 8).ident, ActPC).***
                '                                               otherwise same as below.

                IF mouse_x < 24 THEN '                           experience flag on/off toggle
                    IF weap(al(INT(mouse_y / 16) - 8).ident, ActPC).exchk = 0 THEN 'mouse_y - 9 changed to INT(mouse_y / 16) - 8
                        weap(al(INT(mouse_y / 16) - 8).ident, ActPC).exchk = 1
                    ELSEIF weap(al(INT(mouse_y / 16) - 8).ident, ActPC).exchk = 1 THEN
                        weap(al(INT(mouse_y / 16) - 8).ident, ActPC).exchk = 0
                    END IF
                    _DELAY .25
                END IF
                IF mouse_x > 31 AND mouse_x < 168 THEN '          Weapon name
                    LOCATE INT(mouse_y / 16) + 1, 4: INPUT nm$
                    IF nm$ <> "" THEN
                        weap(al(INT(mouse_y / 16) - 8).ident, ActPC).name = nm$
                    END IF
                END IF
                IF mouse_x > 215 AND mouse_x < 240 THEN '         Attack/Parry percentage
                    LOCATE INT(mouse_y / 16) + 1, 27: INPUT at%
                    IF at% <> 0 THEN
                        weap(al(INT(mouse_y / 16) - 8).ident, ActPC).value = at%
                        Category_Pull weap(al(INT(mouse_y / 16) - 8).ident, ActPC)
                        weap(al(INT(mouse_y / 16) - 8).ident, ActPC).modified = weap(al(INT(mouse_y / 16) - 8).ident, ActPC).modified + 1
                    ELSE
                        'save this spot for 0 entry routine
                    END IF
                END IF
                IF mouse_x > 359 AND mouse_x < 376 THEN '         Weapon damage
                    LOCATE INT(mouse_y / 16) + 1, 45: INPUT weap(al(INT(mouse_y / 16) - 8).ident, ActPC).hpx
                END IF
                '**********************
                'complete weapons list
                '**********************
            END IF
            IF mouse_y > ytop * 16 - 1 AND mouse_y < 624 THEN
                IF mouse_x < 24 THEN 'experience flag
                    IF weap(INT(mouse_y / 16) + 1 - ytop + offset, ActPC).exchk = 0 THEN
                        weap(INT(mouse_y / 16) + 1 - ytop + offset, ActPC).exchk = 1
                    ELSEIF weap(INT(mouse_y / 16) + 1 - ytop + offset, ActPC).exchk = 1 THEN
                        weap(INT(mouse_y / 16) + 1 - ytop + offset, ActPC).exchk = 0
                    END IF
                    _DELAY .25
                END IF
                IF mouse_x > 31 AND mouse_x < 168 THEN '          Weapon name
                    LOCATE INT(mouse_y / 16) + 1, 4: INPUT nm$
                    IF nm$ <> "" THEN
                        weap(INT(mouse_y / 16) + 1 - ytop + offset, ActPC).name = nm$
                    END IF
                END IF
                IF mouse_x > 215 AND mouse_x < 240 THEN '         Attack/Parry percentage
                    LOCATE INT(mouse_y / 16) + 1, 27: INPUT at%
                    IF at% <> 0 THEN
                        weap(INT(mouse_y / 16) + 1 - ytop + offset, ActPC).value = at%
                        Category_Pull weap(INT(mouse_y / 16) + 1 - ytop + offset, ActPC)
                        weap(INT(mouse_y / 16) + 1 - ytop + offset, ActPC).modified = weap(INT(mouse_y / 16) + 1 - ytop + offset, ActPC).modified + 1
                    ELSE
                        'save this spot for 0 entry routine
                    END IF
                END IF
                IF mouse_x > 359 AND mouse_x < 376 THEN '         Weapon damage
                    LOCATE INT(mouse_y / 16) + 1, 45: INPUT weap(INT(mouse_y / 16) + 1 - ytop + offset, ActPC).hpx
                END IF
            END IF
        END IF
        _DISPLAY
        RefreshScreen 3
        IF INKEY$ <> "" THEN EXIT DO
        _LIMIT 50
    LOOP WHILE INKEY$ = ""
    _AUTODISPLAY

END SUB 'Display_Weapons


SUB Dodge_Jump

    '-------------------------ALGORITHM--------------------------------------------------CLEARED
    ' SUB: Dodge_Jump
    '
    ' Purpose:
    ' Calculates DEX based exception of dodge and jump skills testing whether
    ' raised by experience before setting. Used when characteristics change and
    ' those skills have not been previously modified.
    '
    ' Passed Variables:
    ' None
    '
    ' Notes:
    ' May induce a ratcheting effect if DEX changes up and then back down
    ' which is deemed rare enough not to correct. After all, that PC probably needs
    ' all the help he/she can get...;)
    '
    '------------------------------------------------------------------------------------

    '                                                           Dodge
    IF PC_skill(3, ActPC).modified = 0 THEN '                   if unmodified by experience then set base
        PC_skill(3, ActPC).value = char(6, ActPC).value * 2
    ELSE
        '                                                       if experience not higher than base after DEX change
        IF PC_skill(3, ActPC).value < char(6, ActPC).value * 2 THEN
            PC_skill(3, ActPC).value = char(6, ActPC).value * 2
        END IF
    END IF

    '                                                           Jump
    IF PC_skill(5, ActPC).modified = 0 THEN '                   if unmodified by experience then set base
        PC_skill(5, ActPC).value = char(6, ActPC).value * 3
    ELSE
        '                                                       if experience not higher than base after DEX change
        IF PC_skill(5, ActPC).value < char(6, ActPC).value * 3 THEN
            PC_skill(5, ActPC).value = char(6, ActPC).value * 3
        END IF
    END IF

END SUB 'Dodge_Jump


SUB Edit (var AS INTEGER)

    '-------------------------QUERY/DISPLAY/ALGORITHM------------------------------------
    ' SUB: Edit
    '
    ' Purpose:
    ' General editing of characteristics, skills and name. A keyboard based legacy
    ' routine working in tandem with similar functions handled in SUB Mouse_Ops.
    '
    ' Passed Variables:
    ' var sends index of data to be edited
    '
    '------------------------------------------------------------------------------------

    SELECT CASE var
        CASE IS = 1 '                                           alternative screen based characteristic editing REMOVED
        CASE IS = 2 '                                           Legacy skills editing screen REMOVED
        CASE IS = 3 '                                           Choosing the name for the PC
            Choosing_Screen
            LOCATE 1, 16
            COLOR clr&(14)
            PRINT "PC NAME"
            COLOR clr&(15)
            LOCATE 3, 11
            INPUT "->", PCname(ActPC)
        CASE IS = 4 '                                           Removing Active PC from memory CLEARED
            Choosing_Screen
            LOCATE 1, 16
            COLOR clr&(14)
            PRINT "WARNING!"
            COLOR clr&(15)
            LOCATE 3, 1
            PRINT "You are about to remove: "
            PRINT
            PRINT " #"; ActPC; "- "; RTRIM$(PCname(ActPC)); " from the list."
            PRINT
            IF YesOrNo$("Do you wish to proceed? (Y/N)") = "Y" THEN
                x = ActPC
                DO UNTIL x = MaxPC '                            collapse all PCs above the active one down over previous ones
                    Char_In(x) = Char_In(x + 1)
                    Weap_In(x) = Weap_In(x + 1)
                    FOR c = 1 TO 7
                        char(c, x) = char(c, x + 1)
                    NEXT c
                    FOR s = 1 TO 115
                        PC_skill(s, x) = PC_skill(s, x + 1)
                    NEXT s
                    FOR w = 1 TO 56
                        weap(w, x) = weap(w, x + 1)
                    NEXT w
                    Category_Mods x
                    Attributes x
                    MyHome(x) = MyHome(x + 1)
                    Occup(x) = Occup(x + 1)
                    PCname(x) = PCname(x + 1)
                    x = x + 1
                LOOP
                Initialize_PC_Cell MaxPC '                      clear the uppermost data cell
                MaxPC = MaxPC - 1 '                             adjust MaxPC down
                IF MaxPC = 0 THEN '                             program is empty of PCs
                    Initialize_PC_Cell 1
                    Category_Mods 1
                    Attributes 1
                END IF
                IF ActPC > MaxPC THEN ActPC = MaxPC '           lower active counter if MaxPC is the one being removed
            END IF
    END SELECT

END SUB 'Edit


SUB Expand_PC_Count

    '-------------------------ALGORITHM--------------------------------------------------CLEARED
    ' SUB: Expand_PC_Count
    '
    ' Purpose:
    ' Append additional PCs beyond the initial allocation.
    '
    '------------------------------------------------------------------------------------

    'Attributes
    REDIM _PRESERVE hitpoints(MaxPC + 1) AS INTEGER
    REDIM _PRESERVE LegHP(MaxPC + 1) AS INTEGER
    REDIM _PRESERVE AbdmHP(MaxPC + 1) AS INTEGER
    REDIM _PRESERVE ChstHP(MaxPC + 1) AS INTEGER
    REDIM _PRESERVE ArmHP(MaxPC + 1) AS INTEGER
    REDIM _PRESERVE HeadHP(MaxPC + 1) AS INTEGER
    REDIM _PRESERVE magpoints(MaxPC + 1) AS INTEGER
    REDIM _PRESERVE dexsr(MaxPC + 1) AS INTEGER
    REDIM _PRESERVE sizsr(MaxPC + 1) AS INTEGER
    REDIM _PRESERVE basesrm(MaxPC + 1) AS INTEGER
    REDIM _PRESERVE healrate(MaxPC + 1) AS INTEGER
    REDIM _PRESERVE dambonus(MaxPC + 1) AS STRING
    REDIM _PRESERVE sprtcmbtdam(MaxPC + 1) AS STRING
    REDIM _PRESERVE maxenc(MaxPC + 1) AS INTEGER


    'Category Bonuses
    REDIM _PRESERVE Agil(MaxPC + 1) AS INTEGER '                Agility Bonus
    REDIM _PRESERVE Communi(MaxPC + 1) AS INTEGER '             Communication Bonus
    REDIM _PRESERVE Know(MaxPC + 1) AS INTEGER '                Knowledge Bonus
    REDIM _PRESERVE Magic(MaxPC + 1) AS INTEGER '               Magic Bonus
    REDIM _PRESERVE Manip(MaxPC + 1) AS INTEGER '               Manipulation Bonus
    REDIM _PRESERVE Percep(MaxPC + 1) AS INTEGER '              Perception Bonus
    REDIM _PRESERVE Stealth(MaxPC + 1) AS INTEGER '             Stealth Bonus
    REDIM _PRESERVE Melee(MaxPC + 1) AS INTEGER '               Melee Weapons Bonus
    REDIM _PRESERVE Missile(MaxPC + 1) AS INTEGER '             Missile Weapons Bonus
    REDIM _PRESERVE Shield(MaxPC + 1) AS INTEGER '              Shield Bonus
    REDIM _PRESERVE Natur(MaxPC + 1) AS INTEGER '               Natural Weapons Bonus

    REDIM _PRESERVE MyHome(MaxPC + 1) AS STRING * 15
    REDIM _PRESERVE Occup(MaxPC + 1) AS STRING * 15
    REDIM _PRESERVE PCname(MaxPC + 1) AS STRING * 15

    REDIM _PRESERVE Char_In(MaxPC + 1) AS INTEGER '             Prior to characterisics input=0, afterwards=1
    REDIM _PRESERVE Weap_In(MaxPC + 1) AS INTEGER '             Prior to weapons lists=0, afterwards=1
    REDIM _PRESERVE PC_skill(115, MaxPC + 1) AS skill
    REDIM _PRESERVE char(7, MaxPC + 1) AS characteristic
    REDIM _PRESERVE weap(56, MaxPC + 1) AS Arms
    Initialize_PC_Cell MaxPC + 1

END SUB 'Expand_PC_Count


FUNCTION GetAnswer% (prompt$, validChars$)

    '-------------------------QUERY------------------------------------------------------CLEARED
    ' FUNCTION: GetAnswer%
    '
    ' Purpose:
    ' Display a menu prompt.
    ' Get a character of input from the keyboard and return a numerical expression
    ' to represent choice for SELECT CASE or similar control functions. Rejects any
    ' invalid characters entered. A standard library routine stolen from "QBasic
    ' for Dummies". Why reinvent a wheel?
    '
    ' Passed Variables:
    ' prompt$ sends menu prompt to be displayed
    ' validChars$ sends list of acceptable hotkey choices
    '
    '------------------------------------------------------------------------------------

    PRINT prompt$
    DO
        inChar$ = UCASE$(INKEY$)

        charPos% = INSTR(validChars$, inChar$) '                examine the input.
        IF (LEN(inChar$) = 1) AND (charPos% <> 0) THEN
            okchar% = 1
        ELSE
            okchar% = 0
        END IF
    LOOP UNTIL okchar% '                                        Stop looping when a valid character is received.

    GetAnswer% = charPos%

END FUNCTION 'GetAnswer%

SUB HighlightCaps (xprompt$, normcolor&, highcolor&)

    '-------------------------DISPLAY----------------------------------------------------CLEARED
    ' SUB: HighlightCaps
    '
    ' Purpose:
    ' Called from main program loop at Refreshprompt.
    ' Accepts menu string xprompt$ and two color values and applies one color
    ' value to uppercase letters which are hotkey menu choices.
    '
    ' Passed Variables:
    ' xprompt$ sends the menu string to be displayed
    ' normcolor% sends value of normal color
    ' highcolor% sends value of color for uppercase test
    '
    '------------------------------------------------------------------------------------

    FOR x = 1 TO LEN(xprompt$)
        x$ = MID$(xprompt$, x, 1)
        IF UCASE$(x$) <> x$ OR x$ = "/" OR x$ = ":" THEN
            PRINT MID$(xprompt$, x, 1);
        ELSE
            COLOR highcolor&
            PRINT MID$(xprompt$, x, 1);
            COLOR normcolor&
        END IF
    NEXT x

END SUB 'HighlightCaps

SUB Homeland

    '-------------------------QUERY/DISPLAY/ALGORITHM------------------------------------CLEARED
    ' SUB: Homeland
    '
    ' Purpose:
    ' Mouse choice of character's homeland, yielding starting homeland skills.
    '
    ' Passed Variables:
    ' None
    '
    '------------------------------------------------------------------------------------

    IF Char_In(ActPC) = 1 THEN
        RESTORE Home_List
        READ last%
        DIM Hmlnd(last%) AS STRING
        FOR x = 1 TO last%
            READ Hmlnd(x)
        NEXT x

        Choosing_Screen '                                       40 x 17
        COLOR clr&(14)
        LOCATE 1, 6
        PRINT "Roll D10 or Choose Homeland"
        COLOR clr&(15)
        DO
            FOR x = 1 TO last%
                LOCATE x + 2, 12
                IF INT((mouse_y - 15) / 16) = x THEN
                    IF mouse_x > 95 AND mouse_x < 216 THEN COLOR clr&(12)
                END IF
                PRINT x; " "; Hmlnd(x)
                COLOR clr&(15)
            NEXT x

            Mouse_Loop 0, 0, 0
            cho% = Mouse_Point%(2, last%, 95, 216)

            _LIMIT 30
        LOOP UNTIL cho% <> 0
        _DELAY .25

        MyHome(ActPC) = Hmlnd(cho%):
        SELECT CASE cho%
            CASE IS = 1 '                                       Sartar
                Skill_Up 6, 5
                Skill_Up 12, 5
                Skill_Up 18, 10
                Skill_Up 20, 10
                PC_skill(28, ActPC).name = "Heortling customs"
                Skill_Up 33, 20
                Skill_Up 36, 10
                Skill_Up 56, 15
                Skill_Up 79, 15
                Skill_Up 80, 10
                Skill_Up 93, 10
                Skill_Up 101, 10
                Choose_Up 97, 105, 0, 10
                '                                               test for sufficient STR&DEX before assigning 1H OR 2H Battle Axe
                IF char(1, ActPC).value > 12 THEN
                    IF char(6, ActPC).value > 6 OR char(6, ActPC).value + ((char(1, ActPC).value - 13) / 2) > 6 THEN
                        Skill_Up 77, 10
                        weap(2, ActPC).value = PC_skill(7, ActPC).value
                        weap(2, ActPC).modified = weap(2, ActPC).modified + 1
                    END IF
                ELSE
                    Skill_Up 78, 10
                    weap(3, ActPC).value = PC_skill(78, ActPC).value
                    weap(3, ActPC).modified = weap(3, ActPC).modified + 1
                END IF
                Skill_Up 107, 10
                Skill_Up 108, 15
            CASE IS = 2 '                                       Esrolia
                PC_skill(28, ActPC).name = "Esrolian customs"
                Skill_Up 10, 5
                Skill_Up 12, 10
                Skill_Up 16, 5
                Skill_Up 18, 5
                Skill_Up 20, 20
                Skill_Up 33, 25
                Skill_Up 34, 5
                Skill_Up 56, 15
                '                                               test for sufficient STR&DEX before assigning 1H OR 2H Battle Axe
                IF char(1, ActPC).value > 12 THEN
                    IF char(6, ActPC).value > 6 OR char(6, ActPC).value + ((char(1, ActPC).value - 13) / 2) > 6 THEN
                        Skill_Up 77, 15
                        weap(2, ActPC).modified = weap(2, ActPC).modified + 1
                    END IF
                ELSE
                    Skill_Up 78, 15
                    weap(3, ActPC).modified = weap(3, ActPC).modified + 1
                END IF
                Skill_Up 93, 10
                Skill_Up 91, 10
                Skill_Up 104, 10
                Skill_Up 96, 10
                Skill_Up 107, 10
                Skill_Up 108, 15
                Skill_Up 109, 15
            CASE IS = 3 '                                       Grazelands
                PC_skill(28, ActPC).name = "Grazeland customs"
                Skill_Up 6, 35
                Skill_Up 20, 10
                Skill_Up 36, 35
                Skill_Up 56, 15
                Skill_Up 80, 10
                '                                               PC_skill #93  < Lance, weapon #33 chosen premptively
                Skill_Up 93, 15: weap(33, ActPC).value = PC_skill(93, ActPC).value
                weap(33, ActPC).modified = weap(33, ActPC).modified + 1
                Category_Pull weap(33, ActPC)
                Skill_Up 79, 10
                Skill_Up 97, 15
                Skill_Up 108, 10
                Skill_Up 109, 15
            CASE IS = 4 '                                       Prax/Bison tribe
                PC_skill(28, ActPC).name = "Praxian customs"
                char(3, ActPC).value = char(3, ActPC).value + 2: char(6, ActPC).value = char(6, ActPC).value - 2 '+2 SIZ -2 DEX
                char(3, ActPC).max = char(3, ActPC).max + 2
                Max_Dex
                Attributes ActPC
                Category_Mods ActPC
                Recalc_Skills
                Skill_Up 6, 35: PC_skill(6, ActPC).name = "Ride Bison"
                Skill_Up 36, 30
                Skill_Up 43, 15
                Skill_Up 56, 20
                Skill_Up 80, 10
                Skill_Up 93, 15
                Skill_Up 79, 10
                Skill_Up 101, 10
                Skill_Up 108, 10
            CASE IS = 5 '                                       Prax/High Llama tribe
                PC_skill(28, ActPC).name = "Praxian customs"
                char(3, ActPC).value = char(3, ActPC).value + 1: char(6, ActPC).value = char(6, ActPC).value - 1 '+1 SIZ -1 DEX
                char(3, ActPC).max = char(3, ActPC).max + 1
                Max_Dex
                Attributes ActPC
                Category_Mods ActPC
                Recalc_Skills
                Skill_Up 6, 35: PC_skill(6, ActPC).name = "Ride High Llama"
                Skill_Up 36, 30
                Skill_Up 43, 15
                Skill_Up 56, 20
                Skill_Up 80, 10
                Skill_Up 93, 15
                '                                               PC_skill #78 < 2H Axe/Dagger-Axe, weapon #5 chosen preemptively
                weap(5, ActPC).value = weap(5, ActPC).value + 10
                weap(5, ActPC).modified = weap(5, ActPC).modified + 1
                'Category_Pull weap(5, ActPC)
                Skill_Up 102, 10
            CASE IS = 6 '                                       Prax/Impala tribe
                PC_skill(28, ActPC).name = "Praxian customs"
                char(3, ActPC).value = char(3, ActPC).value - 2: char(6, ActPC).value = char(6, ActPC).value + 2 '-2 SIZ +2 DEX
                char(3, ActPC).max = char(3, ActPC).max - 2
                Max_Dex
                Attributes ActPC
                Category_Mods ActPC
                Recalc_Skills
                Skill_Up 6, 35: PC_skill(6, ActPC).name = "Ride Impala"
                Skill_Up 36, 30
                Skill_Up 43, 15
                Skill_Up 56, 20
                Skill_Up 80, 5
                Skill_Up 92, 10
                Skill_Up 97, 20
                '                                               PC_skill #101 < thrown javelin/dart, weapon #46 chosen preemptively
                weap(46, ActPC).value = weap(46, ActPC).value + 10
                weap(46, ActPC).modified = weap(46, ActPC).modified + 1
                Category_Pull weap(46, ActPC)
                Skill_Up 109, 10
            CASE IS = 7 '                                       Prax/Pol-Joni tribe
                PC_skill(28, ActPC).name = "Praxian customs"
                Skill_Up 6, 35: PC_skill(6, ActPC).name = "Ride Horse"
                Skill_Up 36, 30
                Skill_Up 43, 15
                Skill_Up 56, 20
                Skill_Up 80, 10
                '                                               PC_skill #93  < Lance, weapon #33 chosen premptively
                Skill_Up 93, 10: weap(33, ActPC).value = PC_skill(93, ActPC).value
                weap(33, ActPC).modified = weap(33, ActPC).modified + 1
                Category_Pull weap(33, ActPC)
                Skill_Up 79, 15
                Skill_Up 97, 10
                Skill_Up 108, 15
            CASE IS = 8 '                                       Prax/Sable tribe
                PC_skill(28, ActPC).name = "Praxian customs"
                Skill_Up 6, 35: PC_skill(6, ActPC).name = "Ride Sable"
                Skill_Up 36, 30
                Skill_Up 43, 15
                Skill_Up 56, 20
                Skill_Up 80, 10
                Choose_Up 77, 86, 0, 15
                Skill_Up 93, 10
                Choose_Up 97, 101, 0, 10
                Skill_Up 108, 10
            CASE IS = 9 '                                       Lunar Tarsh
                PC_skill(28, ActPC).name = "Lunar customs"
                Skill_Up 12, 5
                Skill_Up 16, 5
                PC_skill(19, ActPC).name = "Spk N. Pelorian"
                Skill_Up 21, 20: PC_skill(21, ActPC).name = "Spk Tarshite"
                Skill_Up 20, 10
                Skill_Up 26, 5
                Skill_Up 33, 25
                Skill_Up 56, 15
                Skill_Up 80, 10
                Skill_Up 86, 10
                Choose_Up 93, 94, 0, 15
                Choose_Up 97, 105, 0, 10
                Skill_Up 101, 10
                Skill_Up 107, 15
                Skill_Up 108, 10
            CASE IS = 10 '                                      Old Tarsh
                Skill_Up 6, 5
                Skill_Up 12, 5
                Skill_Up 18, 10
                PC_skill(19, ActPC).name = "Spk Tarshite"
                Skill_Up 20, 10
                PC_skill(28, ActPC).name = "Tarshite customs"
                Skill_Up 33, 15
                Skill_Up 49, 5
                Skill_Up 56, 15
                Skill_Up 80, 10
                Choose_Up 77, 78, 0, 15
                Skill_Up 93, 10
                Skill_Up 79, 10
                Choose_Up 97, 105, 0, 10
                Skill_Up 101, 10
                Skill_Up 107, 10
                Skill_Up 108, 15
        END SELECT
    END IF

END SUB 'Homeland


SUB Init_Weapons

    '-------------------------ALGORITHM/DISPLAY------------------------------------------CLEARED
    ' SUB: Init_Weapons
    '
    ' Purpose:
    ' Initializes weapon skill values for characters that have had previous experience
    ' from Homeland and Occupation routines.
    '
    ' Passed Variables:
    ' None
    '
    '------------------------------------------------------------------------------------

    IF Weap_In(ActPC) = 0 AND Char_In(ActPC) = 1 THEN '         If already initialized skip to display
        DIM cat_high(4) AS Arms

        FOR x = 1 TO 56 '                                       Initialize for older loaded PCs
            IF weap(x, ActPC).value = 0 THEN
                weap(x, ActPC).cat_per = Manip(ActPC)
                weap(x, ActPC).value = weap(x, ActPC).bs_per + Manip(ActPC) 'set all to base ability
                IF weap(x, ActPC).value < 5 THEN
                    weap(x, ActPC).value = 5 '                  minimum is 5%
                END IF
            END IF
        NEXT x

        FOR loop0 = 77 TO 114
            IF PC_skill(loop0, ActPC).modified > 0 THEN
                FOR loop1 = 1 TO 56 '                           run the full weapons array

                    IF weap(loop1, ActPC).name = PC_skill(loop0, ActPC).name THEN 'if skill AND weapons match names  (swords & shields)
                        weap(loop1, ActPC).value = PC_skill(loop0, ActPC).value 'set weapon to skill
                        weap(loop1, ActPC).modified = PC_skill(loop0, ActPC).modified
                        Category_Pull weap(loop1, ActPC)
                    END IF

                    'if skill name matches weapon category (axes, spears,etc)
                    IF weap(loop1, ActPC).cate = PC_skill(loop0, ActPC).name AND weap(loop1, ActPC).init = 0 THEN
                        cat = 0

                        FOR loop2 = 1 TO 56 '                   collect all in one skill element, putting in cat_high
                            IF weap(loop2, ActPC).cate = weap(loop1, ActPC).cate THEN
                                cat = cat + 1
                                cat_high(cat) = weap(loop2, ActPC)
                                weap(loop2, ActPC).init = 1
                            END IF
                        NEXT loop2

                        IF cat = 1 THEN
                            weap(cat_high(cat).ident, ActPC).value = PC_skill(cat_high(cat).link, ActPC).value
                            weap(cat_high(cat).ident, ActPC).init = 1
                            weap(cat_high(cat).ident, ActPC).modified = PC_skill(cat_high(cat).link, ActPC).modified
                        ELSE
                            Choosing_Screen
                            COLOR clr&(14)
                            LOCATE 1, 12
                            PRINT "CHOOSE "; cat_high(cat).cate
                            COLOR clr&(15)
                            DO
                                'print list
                                FOR b% = 1 TO cat
                                    LOCATE b% + 2, 12
                                    IF cat_high(b%).modified > 0 THEN COLOR clr&(9)
                                    IF INT((mouse_y - 15) / 16) = b% AND mouse_x > 88 AND mouse_x < 193 THEN COLOR clr&(12), clr&(0)
                                    PRINT b%; "- "; cat_high(b%).name
                                    COLOR clr&(15)
                                NEXT b%

                                Mouse_Loop 0, 0, 0
                                cho% = Mouse_Point(2, cat, 96, 256)
                                _LIMIT 100
                            LOOP UNTIL cho% <> 0
                            _DELAY .25

                        END IF
                        'set weapon skill
                        weap(cat_high(cho%).ident, ActPC).value = PC_skill(cat_high(cho%).link, ActPC).value
                        weap(cat_high(cho%).ident, ActPC).modified = PC_skill(cat_high(cho%).link, ActPC).modified
                        Category_Pull weap(cat_high(cho%).ident, ActPC)
                    END IF

                NEXT loop1
            END IF
        NEXT loop0
        Weap_In(ActPC) = 1
    END IF
    RefreshScreen 2
    Display_Weapons

END SUB 'Init_Weapons


SUB Initialize_PC_Cell (var AS INTEGER)

    '-------------------------ALGORITHM--------------------------------------------------CLEARED
    ' SUB: Initialize_PC_Cell
    '
    ' Purpose:
    ' Clear variables in a singular PC cell for future use, setting all base array
    ' elements. Called from main module 10x for opening set up and called from
    ' SUB Edit in deletion routine to clear former MaxPC data.
    '
    ' Passed variables:
    ' var sends PC cell number to be initialized
    '
    '------------------------------------------------------------------------------------

    Char_In(var) = 0 '                                          Characteristics not yet entered
    Weap_In(var) = 0 '                                          Character's weapons not yet set
    MyHome(var) = "Click/Homeland"
    Occup(var) = "Click/Occupation"
    PCname(var) = "Click/Name"

    RESTORE skills
    FOR x = 1 TO 113
        PC_skill(x, var).ident = x
        READ PC_skill(x, var).category, PC_skill(x, var).name, PC_skill(x, var).base_per
        PC_skill(x, var).modified = 0
        PC_skill(x, var).value = 0
        PC_skill(x, var).cat_per = 0
        PC_skill(x, var).exchk = 0
    NEXT x
    PC_skill(114, var).ident = 114
    READ PC_skill(114, var).category, PC_skill(114, var).name, PC_skill(114, var).base_per
    PC_skill(115, var).ident = 115

    RESTORE characteristic
    FOR y = 1 TO 7
        READ char(y, var).name, char(y, var).abrev, char(y, var).dice
        char(y, var).value = 0
    NEXT y

    RESTORE armaments
    FOR y = 1 TO 56
        weap(y, var).ident = y
        READ weap(y, var).cate
        READ weap(y, var).name
        READ weap(y, var).bs_per
        READ weap(y, var).str
        READ weap(y, var).dex
        READ weap(y, var).damage
        READ weap(y, var).bsr
        READ weap(y, var).enc
        READ weap(y, var).hp
        READ weap(y, var).link
        weap(y, var).modified = 0
        weap(y, var).init = 0
        weap(y, var).exchk = 0
        weap(y, var).value = 0
        weap(y, var).hpx = weap(y, var).hp
    NEXT y

END SUB 'Initialize_PC_Cell


SUB Load_PC (var AS STRING, var2 AS INTEGER)

    '-------------------------ALGORITHM--------------------------------------------------CLEARED
    ' SUB: Load_PC
    '
    ' Purpose:
    ' Loads a previously saved character into memory
    '
    ' Passed Variables:
    ' var sends whether this is an individual load or a batch load
    ' var2 sends ActPC value if a batch load
    '
    '------------------------------------------------------------------------------------

    IF var = "I" THEN '                                         control ActPC locally
        Choosing_Screen
        head$ = "LOAD CHARACTER"

        SELECT CASE MaxPC
            CASE IS = 0
                ActPC = 1
                MaxPC = MaxPC + 1
            CASE 1 TO 9
                ActPC = MaxPC + 1
                MaxPC = MaxPC + 1
            CASE IS >= 10
                Expand_PC_Count
                ActPC = MaxPC + 1
                MaxPC = MaxPC + 1
        END SELECT
        LOCATE 1, 13
        COLOR clr&(14)
        PRINT head$
        COLOR clr&(15)
        LOCATE 4, 1
        PRINT "Input name of character"
        LOCATE 6, 10
        INPUT "->", PCname(ActPC)
    ELSEIF var = "B" THEN '                                     control ActPC from SUB Batch_Load
        ActPC = var2
        'IF ActPC > 10 THEN
        '    Expand_PC_Count
        'END IF
    END IF
    filename$ = "data\" + PCname(ActPC) + ".pc1"
    IF _FILEEXISTS(filename$) THEN
        OPEN filename$ FOR INPUT AS #1
        INPUT #1, pc_ver_p, pc_ver_s, pc_ver_t, PCname(ActPC), MyHome(ActPC), Occup(ActPC), Char_In(ActPC), Weap_In(ActPC)
        CLOSE #1

        'version ops and upgrades go here***************************************************************************
        IF pc_ver_p < ver_p THEN
            IF pc_ver_s < ver_s THEN
                IF pc_ver_t < ver_t THEN
                END IF
            END IF
        END IF
    ELSE
        LOCATE 12, 8
        PRINT "Character not present."
        LOCATE 13, 5
        PRINT "Check spelling and try again."
        SLEEP 3
        ActPC = ActPC - 1
        MaxPC = MaxPC - 1
        EXIT SUB
    END IF

    filename$ = "data\" + PCname(ActPC) + ".pc2"
    OPEN filename$ FOR RANDOM AS #2 LEN = LEN(char(1, ActPC))
    FOR x = 1 TO 7
        GET #2, x, char(x, ActPC)
    NEXT x
    CLOSE #2
    filename$ = "data\" + PCname(ActPC) + ".pc3"
    OPEN filename$ FOR RANDOM AS #3 LEN = LEN(PC_skill(1, ActPC))
    FOR x = 1 TO 115
        GET #3, x, PC_skill(x, ActPC)
    NEXT x
    CLOSE #3
    'Correcting older version character's lack of two blank skill slot numbering
    IF PC_skill(114, ActPC).ident = 0 THEN PC_skill(114, ActPC).ident = 114
    IF PC_skill(115, ActPC).ident = 0 THEN PC_skill(115, ActPC).ident = 115
    IF Weap_In(ActPC) = 1 THEN
        filename$ = "data\" + PCname(ActPC) + ".pc4"
        OPEN filename$ FOR RANDOM AS #4 LEN = LEN(weap(1, ActPC))
        FOR x = 1 TO 56
            GET #4, x, weap(x, ActPC)
        NEXT x
        CLOSE #4
    END IF

END SUB 'Load_PC


SUB Lore_Choice (var1 AS INTEGER, var2 AS STRING)

    '-------------------------QUERY/DISPLAY----------------------------------------------CLEARED
    ' SUB: Lore_Choice
    '
    ' Purpose:
    ' Conducts choice of Lore skills
    '
    ' Passed Variables:
    ' var1 sends skill increment to be applied
    ' var2 sends "primary"/"secondary"/ etc. classifications of choices.
    '
    '------------------------------------------------------------------------------------

    RESTORE Lore_List '                                         Set data for Lore_List and read data
    READ last%
    DIM temp%(last%)
    FOR x = 1 TO last%
        READ temp%(x)
    NEXT x

    Choosing_Screen
    COLOR clr&(14)
    IF var2 <> "" THEN
        LOCATE 1, 7
        PRINT "Choose "; var2; " Lore ("; var1; ")"
    ELSE
        LOCATE 1, 11
        PRINT "Choose Lore ("; var1; ")"
    END IF
    COLOR clr&(15)
    DO
        'Print the list
        FOR x = 1 TO last%
            IF INT((mouse_y - 15) / 16) = x AND mouse_x > 40 AND mouse_x < 264 THEN m_over = 1
            LOCATE x + 2, 6
            Color_Test LTRIM$(STR$(x)), temp%(x), m_over
            m_over = 0
        NEXT x

        Mouse_Loop 0, 0, 0
        cho% = Mouse_Point(2, last%, 40, 264)

        _LIMIT 50
    LOOP UNTIL cho% <> 0
    _DELAY .25

    Skill_Up temp%(cho%), var1

END SUB 'Lore_Choice


SUB Max_Dex

    '-------------------------ALGORITHM--------------------------------------------------CLEARED
    ' SUB: Max_Dex
    '
    ' Purpose:
    ' Sets the maximum dexterity value for the active character.
    '
    ' Passed Variables:
    ' None
    '
    '------------------------------------------------------------------------------------

    IF char(6, ActPC).value * 1.5 <> INT(char(6, ActPC).value * 1.5) THEN
        char(6, ActPC).max = INT((char(6, ActPC).value * 1.5) + 1)
    ELSE
        char(6, ActPC).max = char(6, ActPC).value * 1.5
    END IF
    IF char(6, ActPC).max > 21 THEN char(6, ActPC).max = 21

END SUB 'Max_Dex


SUB Mouse_List (vartype AS INTEGER, index AS INTEGER, ytop AS INTEGER, ybase AS INTEGER)

    '-------------------------QUERY/DISPLAY----------------------------------------------
    ' SUB: Mouse_List
    '
    ' Purpose:
    ' Conducts mouse based editing routines. Specific routine determined by "vartype".
    ' Designed for future expansion or subsuming other existing routines.
    '
    ' Passed Variables:
    ' vartype sends index of routine to employ on the call (SELECT CASE removed)
    ' index sends "0" in lieu of data to be determined in future expansions
    ' ytop sends value of upper row range of data display
    ' ybase sends value of lower row range of data display
    '
    '------------------------------------------------------------------------------------

    offset = 0
    bottom = ybase - ytop
    roto_put_y = ytop * 16 - 8
    roto_put_x = 250
    DO
        COLOR clr&(14) '                                Footer instruction display
        LOCATE 40, 1
        PRINT "hover and left click to edit, any key or right click to exit,"
        LOCATE 41, 1
        PRINT "arrow hover fast scrolls, mouse wheel slow scrolls";

        'Printing the list
        FOR x = 1 TO bottom
            IF x = 1 THEN '                             Print the upper arrow indicator
                IF offset > 0 THEN '                    If there's more data above the displayed area
                    IF mouse_y > ytop * 16 - 17 AND mouse_y < ytop * 16 - 1 AND mouse_x > roto_put_x - 40 AND mouse_x < roto_put_x + 40 THEN
                        offset = offset - 1 '           decrement offset when mouse over upper arrow
                    END IF
                    RotoZoom2 roto_put_x, roto_put_y, arrows, 1, 1, 0 'Place the upper scroll arrow pointing up
                ELSE
                    GOTO No_offset
                END IF
            ELSEIF x = bottom THEN '                    Print the lower arrow indicator
                IF offset + x < UBOUND(PC_skill, 1) THEN 'If there's more data below the displayed area
                    IF mouse_y > ybase * 16 - 33 AND mouse_y < ybase * 16 - 17 AND mouse_x > roto_put_x - 40 AND mouse_x < roto_put_x + 40 THEN
                        offset = offset + 1 '           Increment offset when mouse over lower arrow
                    END IF
                    roto_put_down = roto_put_y + ((x - 1) * 16) 'Calculate lower arrow y position
                    RotoZoom2 roto_put_x, roto_put_down, arrows, 1, 1, 180 'Place the lower scroll arrow pointing down
                ELSE
                    GOTO No_offset
                END IF
            ELSE '                                      Print the skill data fields
                No_offset:
                ysi = (x + (ytop - 1)) * 16 - 17 '      Convert data insertion point to mouse coordinates
                yse = (x + (ytop - 1)) * 16 - 1
                COLOR clr&(15)
                IF mouse_y > ysi AND mouse_y < yse AND mouse_x > 119 AND mouse_x < 144 THEN COLOR clr&(12)
                IF PC_skill(x + offset, ActPC).exchk = 1 THEN
                    LOCATE x + (ytop - 1), 16: PRINT "[X]";
                ELSE
                    LOCATE x + (ytop - 1), 16: PRINT "[ ]";
                END IF
                COLOR clr&(15)
                IF PC_skill(x + offset, ActPC).modified > 0 THEN COLOR clr&(10)
                LOCATE x + (ytop - 1), 20: PRINT USING "###"; PC_skill(x + offset, ActPC).ident
                IF mouse_y > ysi AND mouse_y < yse AND mouse_x > 183 AND mouse_x < 328 THEN
                    COLOR clr&(12)
                END IF
                LOCATE x + (ytop - 1), 24: PRINT PC_skill(x + offset, ActPC).name
                COLOR clr&(15)
                IF PC_skill(x + offset, ActPC).modified > 0 THEN COLOR clr&(10)
                IF mouse_y > ysi AND mouse_y < yse AND mouse_x > 343 AND mouse_x < 368 THEN
                    COLOR clr&(12)
                END IF
                LOCATE x + (ytop - 1), 44: PRINT USING "###"; PC_skill(x + offset, ActPC).value
                LOCATE x + (ytop - 1), 48: PRINT " x"; PC_skill(x + offset, ActPC).modified
                COLOR clr&(15)
            END IF
        NEXT x

        Mouse_Loop 1, 86, offset
        mouse_in = _MOUSEBUTTON(1)
        mouse_out = _MOUSEBUTTON(2)
        IF mouse_out = -1 THEN
            _AUTODISPLAY
            EXIT SUB
        END IF
        IF mouse_in = -1 THEN
            IF mouse_y >= ytop * 16 - 17 AND mouse_y <= ybase * 16 - 17 THEN
                mpl% = INT((mouse_y - (ytop + 1) * 16) / 16) + 3 ' previously (mouse_y - ytop + 1)
                IF mouse_x > 119 AND mouse_x < 144 THEN 'set/clear experience check flag
                    IF PC_skill(offset + mpl%, ActPC).exchk = 1 THEN
                        PC_skill(offset + mpl%, ActPC).exchk = 0
                    ELSE
                        PC_skill(offset + mpl%, ActPC).exchk = 1
                    END IF
                    _DELAY .25
                ELSEIF mouse_x > 183 AND mouse_x < 328 THEN 'name editing code
                    LOCATE INT(mouse_y / 16) + 1, 23
                    INPUT a$
                    IF a$ <> "" THEN
                        PC_skill(offset + mpl%, ActPC).name = a$
                    END IF
                ELSEIF mouse_x > 343 AND mouse_x < 368 THEN 'value editing code
                    LOCATE INT(mouse_y / 16) + 1, 43
                    INPUT PC_skill(offset + mpl%, ActPC).value
                    PC_skill(offset + mpl%, ActPC).modified = PC_skill(offset + mpl%, ActPC).modified + 1
                END IF
            END IF
        END IF
        _DISPLAY
        RefreshScreen 3 '                               Re-display main screen with blank skill/weapon window
        _LIMIT 50
    LOOP UNTIL INKEY$ <> "" '                           End of skill edit routine
    _AUTODISPLAY

END SUB 'Mouse_List


SUB Mouse_Loop (var AS INTEGER, var2 AS INTEGER, var3 AS INTEGER)

    '-------------------------ALGORITHM--------------------------------------------------CLEARED
    ' SUB: Mouse_Loop
    '
    ' Purpose:
    ' Primary mouse input loop. Controls mousewheel scrolling and conditions
    ' x,y position data.
    '
    ' Passed Variables:
    ' var sends whether data list is extensive enough for using offset printing values
    ' var2 sends maximum allowed offset value
    '
    '------------------------------------------------------------------------------------

    DO WHILE _MOUSEINPUT '                                      scan for changes in mouse position and save to global variables
        IF var = 1 THEN
            var3 = var3 + _MOUSEWHEEL '                     mousewheel offset determines starting element to print
            IF var3 < 0 THEN var3 = 0 '                     don't go beyond bottom of array
            IF var3 > var2 THEN var3 = var2 '               don't go beyond the end of the array
        END IF
        mouse_y = _MOUSEY
        mouse_x = _MOUSEX
    LOOP

END SUB 'Mouse_Loop


SUB Mouse_Ops (xpos AS INTEGER, ypos AS INTEGER)

    '-------------------------ALGORITHM--------------------------------------------------CLEARED
    ' SUB: Mouse_Ops
    '
    ' Purpose:
    ' Receives mouse x,y positional data from main program loop (RefreshPrompt) on
    ' mouse click and directs flow of control to appropriate subroutines.
    '
    ' Passed Variables:
    ' xpos sends the column position of mouse pointer
    ' ypos sends the row position of mouse pointer
    '
    '------------------------------------------------------------------------------------

    SELECT CASE xpos
        CASE 0 TO 639
            SELECT CASE ypos
                CASE 0 TO 111 '                                 If clicking in the header
                    SELECT CASE xpos
                        CASE 40 TO 54
                            IF Char_In(ActPC) = 0 THEN
                                Characteristic_In
                                EXIT SUB
                            ELSE '                              Edit preexisting characteristics
                                x = INT(ypos / 16) + 1
                                Char_Click x
                                EXIT SUB
                            END IF
                        CASE 425 TO 527
                            IF ypos > 95 AND ypos < 112 AND ActPC > 0 THEN 'mouse select homeland
                                Homeland
                            END IF
                    END SELECT
                CASE 112 TO 127
                    SELECT CASE xpos
                        CASE 0 TO 119
                            IF ActPC > 0 THEN '                 call Edit SUB w/ name identifier
                                Edit 3
                            END IF
                        CASE 425 TO 527
                            IF ActPC > 0 THEN '                 mouse select occupation
                                Occupation
                            END IF
                    END SELECT
                CASE 128 TO 607
                    Mouse_List 1, 1, 10, 39
                CASE 624 TO 639
                    IF Char_In(ActPC) = 0 THEN '                row 40 STARTING COMMAND PROMPT
                        SELECT CASE xpos
                            CASE 0 TO 119 '                     characterisics
                                Characteristic_In
                            CASE 136 TO 167 '                   load PC
                                Load_PC "I", 0
                                Attributes ActPC
                                Category_Mods ActPC
                            CASE 184 TO 215 '                   quit
                                SYSTEM
                        END SELECT
                    ELSEIF Char_In(ActPC) = 1 THEN '            row 40 FULL COMMAND PROMPT
                        SELECT CASE xpos
                            CASE 0 TO 31 '                      new
                                IF MaxPC < 10 THEN
                                    ActPC = MaxPC + 1
                                    Characteristic_In
                                ELSEIF MaxPC >= 10 THEN
                                    Expand_PC_Count
                                    ActPC = MaxPC + 1
                                    Characteristic_In
                                END IF
                            CASE 40 TO 103 '                    homeland  {40 to 103}  88 TO 151
                                Homeland
                            CASE 120 TO 199 '                   occupation  {120 to 199}   168 TO 247
                                Occupation
                            CASE 216 TO 271 '                   weapons  {216 to 271}     264 TO 319
                                Init_Weapons
                            CASE 288 TO 319 '                   Load PC  {288 to 319}    336 TO 367
                                Load_PC "I", 0
                                Attributes ActPC
                                Category_Mods ActPC
                            CASE 335 TO 367 '                   Save PC  {335 to 367}  383 TO 415
                                Save_PC
                            CASE 384 TO 431 '                   Remove Active PC from memory  {384 to 431}   432 TO 479
                                Edit 4
                            CASE 448 TO 489 '                   quit {448 to 489}   496 TO 537
                                SYSTEM
                        END SELECT
                    END IF
            END SELECT
        CASE 640 TO 799
            'place code for right side of screen here
            SELECT CASE ypos
                CASE 0 TO 287 '                                 Hit point man
                CASE 288 TO 527 '                               Loaded list limit to higher of MaxPC or 15
                    IF offact > 0 THEN
                        ActPC = INT((mouse_y - 287) / 16) + 1 + offact 'Set active PC
                    ELSE
                        x = ActPC
                        ActPC = INT((mouse_y - 287) / 16) + 1
                        IF ActPC > MaxPC THEN ActPC = x
                    END IF
                    IF AcrPC > MaxPC THEN ActPC = MaxPC
                CASE 568 TO 618
                    IF xpos > 663 AND xpos < 775 THEN Batch_Load
                CASE 628 TO 678
                    IF xpos > 663 AND xpos < 775 THEN Batch_Save
            END SELECT
    END SELECT

END SUB 'Mouse_Ops


SUB Mouse_Over_Active

    '-------------------------DISPLAY----------------------------------------------------
    ' SUB: Mouse_Over_Active
    '
    ' Purpose:
    ' display right hand loaded PCs list
    '
    ' Passed variables:
    ' None
    '
    '------------------------------------------------------------------------------------

    LOCATE 17, 85
    COLOR clr&(14)
    PRINT "Loaded List"
    L% = MaxPC
    IF L% > 15 THEN L% = 15
    _PUTIMAGE (641, 271)-(790, 543), port_cover, disp_main, (641, 271)-(790, 543) 'paper over previous
    sz% = MaxPC * 16
    IF sz% > 240 THEN sz% = 240
    LINE (640, 248)-(791, 304 + sz%), clr&(14), B '             add -(791, 304+sz%) was 544
    FOR a = 1 TO L% '                                           print PC list
        COLOR clr&(7)
        LOCATE 18 + a, 82
        IF a = ActPC - offact THEN COLOR clr&(14)
        IF MID$(PCname(a + offact), 1, 6) = "Click/" THEN
            PRINT "unnamed #" + STR$(a + offact)
        ELSE
            PRINT PCname(a + offact)
        END IF
    NEXT a
    _DISPLAY

END SUB 'Mouse_Over_Active


FUNCTION Mouse_Point% (trim_top AS INTEGER, last_item AS INTEGER, left_x AS INTEGER, right_x AS INTEGER)

    '-------------------------ALGORITHM--------------------------------------------------CLEARED
    ' FUNCTION: Mouse_Point%
    '
    ' Purpose:
    ' Returns the row position and column range of a mouse pointer on left click.
    ' Used for one element choice routines.
    '
    ' Passed Variables:
    ' trim_top sends value to be trimmed from row position to mark start of data list
    ' last item sends value of last data item displayed
    ' left_x sends leftmost allowed point of selection of data element
    ' right_x sends rightmost allowed point of selection of data element
    '
    '------------------------------------------------------------------------------------

    mouse_in = _MOUSEBUTTON(1)
    IF mouse_in = -1 THEN
        ypos = INT((mouse_y - (trim_top * 16)) / 16) + 1
        IF ypos > 0 AND ypos < last_item + 1 THEN
            IF mouse_x > left_x AND mouse_x < right_x THEN
                Mouse_Point% = ypos
            END IF
        END IF
    END IF

END FUNCTION 'Mouse_Point%


SUB Occupation

    '-------------------------QUERY/DISPLAY/ALGORITHM------------------------------------CLEARED
    ' SUB: Occupation
    '
    ' Purpose:
    ' Mouse choice of character's occupation, yielding starting occupation skills.
    '
    ' Passed Variables:
    ' None
    '
    '------------------------------------------------------------------------------------

    IF Char_In(ActPC) = 1 THEN
        '                                                       Set up occupation strings
        RESTORE Occu_List
        READ last%
        DIM temp$(last%)
        FOR x = 1 TO last%
            READ temp$(x)
        NEXT x

        SCREEN oc_win '                                         Initiate Occupation window
        _DEST oc_win
        CLS
        _PUTIMAGE , back_main
        _PRINTMODE _KEEPBACKGROUND

        LOCATE 1, 15
        COLOR clr&(14)
        PRINT "Roll D20 or choose Occupation"
        COLOR clr&(15)
        DO
            FOR x = 1 TO last% '                                Display Occupation strings
                LOCATE x + 2, 5
                IF INT((mouse_y - 15) / 16) = x THEN
                    IF mouse_x > 0 AND mouse_x < 320 THEN COLOR clr&(12)
                END IF
                PRINT temp$(x)
                COLOR clr&(14)
            NEXT x

            Mouse_Loop 0, 0, 0
            cho% = Mouse_Point%(2, last%, 39, 320) '            Get Occupation input

            _LIMIT 30
        LOOP UNTIL cho% <> 0
        _DELAY .25

        SELECT CASE cho% '                                      increment occupation skills
            CASE IS = 1
                Occup(ActPC) = "Asst Shaman"
                Skill_Up 21, 20: PC_skill(21, ActPC).name = "Spirit Speech"
                Skill_Up 18, 10
                Skill_Up 56, 30
                Skill_Up 23, 15
                Skill_Up 57, 10
                Skill_Up 34, 15
                Skill_Up 58, 20
                Skill_Up 44, 20
                Skill_Up 59, 20
                Skill_Up 52, 20
            CASE IS = 2
                Occup(ActPC) = "Bandit"
                Skill_Up 15, 10
                Skill_Up 75, 30
                Skill_Up 34, 10
                Skill_Up 74, 10
                Skill_Up 49, 30
                Choose_Up 23, 44, 0, 10
                Weapon_Choice "ALL", 30, "primary"
                Weapon_Choice "ALL", 10, "secondary"
                Choose_Up 107, 108, 109, 10
            CASE IS = 3
                Occup(ActPC) = "Chariot Driver"
                Skill_Up 24, 20
                Skill_Up 34, 10
                Skill_Up 4, 40
                Skill_Up 12, 15
                Skill_Up 72, 15
                Skill_Up 102, 25: PC_skill(102, ActPC).name = "Whip"
                weap(37, ActPC).name = "Whip"
                weap(37, ActPC).value = PC_skill(102, ActPC).value
                weap(37, ActPC).modified = weap(37, ActPC).modified + 1
                Weapon_Choice "ALL", 20, "primary"
                Weapon_Choice "MS", 20, "missile"
            CASE IS = 4
                Occup(ActPC) = "Crafter"
                Skill_Up 9, 10
                Skill_Up 32, 10
                Skill_Up 10, 10
                Skill_Up 65, 15
                Skill_Up 41, 30
                Skill_Up 68, 10
                Craft_Choice 30, "primary"
                Craft_Choice 20, "secondary"
                Lore_Choice 10, ""
                Weapon_Choice "ALL", 15, "primary"
            CASE IS = 5
                Occup(ActPC) = "Entertainer"
                Skill_Up 12, 30
                Skill_Up 29, 10
                Skill_Up 17, 10
                Skill_Up 68, 10
                Skill_Up 18, 30
                Skill_Up 19, 30
                Skill_Up 66, 30
                Lore_Choice 10, ""
                Weapon_Choice "ALL", 15, "primary"
            CASE IS = 6
                Occup(ActPC) = "Farmer"
                Skill_Up 37, 15
                Skill_Up 34, 10
                Skill_Up 72, 10
                Skill_Up 36, 15
                Skill_Up 33, 30
                Skill_Up 41, 30
                Choose_Up 2, 5, 0, 10
                Craft_Choice 15, ""
                Weapon_Choice "ALL", 15, "primary"
                Choose_Up 107, 108, 109, 15
            CASE IS = 7
                Occup(ActPC) = "Fisher"
                Skill_Up 1, 30
                Skill_Up 38, 30
                Skill_Up 72, 10
                'PC_skill(93, ActPC).name = "1H Short Spear"
                Skill_Up 93, 10
                Skill_Up 34, 10
                Skill_Up 7, 30
                PC_skill(102, ActPC).name = "Thrown Net"
                weap(37, ActPC).name = "Thrown Net"
                Choose_Up 101, 104, 102, 20
                Choose_Up 107, 108, 109, 10
                PC_skill(38, ActPC).name = "River Lore"
            CASE IS = 8
                Occup(ActPC) = "Healer"
                Skill_Up 17, 10
                Skill_Up 50, 30
                Skill_Up 22, 10
                Skill_Up 51, 10
                Skill_Up 34, 30
                Skill_Up 65, 10
                Skill_Up 44, 30
                Skill_Up 68, 10
            CASE IS = 9
                Occup(ActPC) = "Herder"
                Skill_Up 34, 10
                Skill_Up 72, 10
                Skill_Up 23, 10
                Skill_Up 74, 10
                Skill_Up 37, 10
                Skill_Up 36, 30
                Skill_Up 43, 30
                Choose_Up 5, 2, 0, 10
                Weapon_Choice "MS", 30, "cultural missile"
                Weapon_Choice "ALL", 10, "cultural"
                Choose_Up 107, 108, 109, 10
            CASE IS = 10
                Occup(ActPC) = "Hunter"
                Skill_Up 23, 30
                Skill_Up 72, 10
                Skill_Up 37, 10
                Skill_Up 74, 30
                Skill_Up 62, 10
                Skill_Up 75, 10
                Skill_Up 71, 10
                Weapon_Choice "MS", 30, "cultural missile"
            CASE IS = 11
                Occup(ActPC) = "Merchant"
                Skill_Up 20, 30
                Skill_Up 41, 30
                Skill_Up 32, 30
                Skill_Up 6, 10
                Skill_Up 29, 10
                Skill_Up 10, 30
                Skill_Up 68, 10
                Skill_Up 21, 10
                PC_skill(46, ActPC).name = "R/W Tradetalk"
                Choose_Up 45, 46, 47, 10
            CASE IS = 12
                Occup(ActPC) = "Noble"
                Skill_Up 68, 10
                Skill_Up 16, 10
                Skill_Up 45, 10
                Skill_Up 17, 30
                Skill_Up 41, 30
                Skill_Up 19, 10
                Skill_Up 28, 10
                Choose_Up 6, 4, 0, 10
                Choose_Up 107, 108, 109, 30
                Weapon_Choice "ALL", 30, "cultural"
            CASE IS = 13
                Occup(ActPC) = "Philosopher"
                Skill_Up 111, 10
                Skill_Up 17, 25
                Skill_Up 52, 20
                Skill_Up 110, 20
                Skill_Up 40, 10
                Skill_Up 112, 10
                Choose_Up 45, 46, 47, 50
                Lore_Choice 30, "primary"
                Lore_Choice 10, "secondary"
            CASE IS = 14
                Occup(ActPC) = "Priest"
                Skill_Up 113, 10
                Skill_Up 27, 30
                Skill_Up 12, 10
                Skill_Up 45, 10
                Skill_Up 17, 10
                Skill_Up 41, 10
                Skill_Up 18, 30
                Skill_Up 61, 30
                Skill_Up 52, 10
            CASE IS = 15
                Occup(ActPC) = "Scribe"
                Skill_Up 40, 10
                Skill_Up 45, 50
                Skill_Up 32, 10
                Skill_Up 25, 30
                Lore_Choice 30, "primary"
                Lore_Choice 10, "secondary"
                Choose_Up 19, 20, 21, 10
                Choose_Up 28, 29, 30, 30
                Choose_Up 45, 46, 47, 30
            CASE IS = 16
                Occup(ActPC) = "Thief"
                Skill_Up 2, 10
                Skill_Up 65, 10
                Skill_Up 13, 30
                Skill_Up 67, 30
                Skill_Up 14, 30
                Skill_Up 75, 10
                Skill_Up 37, 10
                Skill_Up 76, 30
                Weapon_Choice "ALL", 15, "cultural"
            CASE IS = 17
                RESTORE Warrior_List
                READ last%
                REDIM temp$(last%)
                FOR x = 1 TO last%
                    READ temp$(x)
                NEXT x

                Choosing_Screen
                COLOR clr&(14)
                LOCATE 1, 13: PRINT "Choose service"
                COLOR clr&(15)
                DO
                    FOR x = 1 TO last%
                        LOCATE x + 2, 13
                        IF INT((mouse_y - 15) / 16) = x THEN
                            IF mouse_x > 96 AND mouse_x < 208 THEN COLOR clr&(12)
                        END IF
                        PRINT x; " "; temp$(x)
                        COLOR clr&(15)
                    NEXT x

                    Mouse_Loop 0, 0, 0
                    cho2% = Mouse_Point%(2, last%, 96, 208)

                    _LIMIT 30
                LOOP UNTIL cho2% <> 0
                _DELAY .25

                SELECT CASE cho2%
                    CASE IS = 1
                        Warrior_Heavy_Infantry
                    CASE IS = 2
                        Warrior_Light_Infantry
                    CASE IS = 3
                        Warrior_Heavy_Cavalry
                    CASE IS = 4
                        Warrior_Light_Cavalry
                END SELECT
        END SELECT
    END IF

END SUB 'Occupation


SUB Occupation_Screen

    '-------------------------DISPLAY----------------------------------------------------CLEARED
    ' SUB: Occupation_Screen
    '
    ' Purpose:
    ' Sets parameters for and displays general pupose data view ports in wider format
    ' than Choosing_Screen
    '
    ' Passed Variables:
    ' None
    '
    '------------------------------------------------------------------------------------

    SCREEN oc_win
    _DEST oc_win
    CLS
    _PUTIMAGE , back_main
    _PRINTMODE _KEEPBACKGROUND

END SUB 'Occupation_Screen


SUB Prnt (text AS STRING, size AS INTEGER, StartX AS INTEGER, StartY AS INTEGER, Xspace AS INTEGER, Yspace AS INTEGER)

    '------------------------------------------------------------------------------------
    ' SUB: Prnt (adaptation of Petr's excellent approach to text resizing)
    '
    ' Purpose:
    ' Display text as resizable images that have been previously defined in the main
    ' module.
    '
    ' Passed parameters:
    ' text sends string value to be printed
    ' size sends size of text to be displayed: 1=original
    ' StartX sends upper left x position for _PUTIMAGE
    ' StartY sends upper left y position for _PUTIMAGE
    ' Xspace sends horizontal spacing
    ' Yspace sends vertical spacing
    '
    '------------------------------------------------------------------------------------

    x = StartX
    y = StartY
    FOR f = 1 TO LEN(text)
        ch = ASC(text, f)
        x = x + Xspace
        _CLEARCOLOR _RGB(0, 0, 0), chr_img(ch)
        _PUTIMAGE (x, y)-(x + (size * 8), y + (size * 16)), chr_img(ch), 0
    NEXT f

END SUB 'Prnt


SUB Print_Arms (var1 AS INTEGER, var3 AS Arms, textcol AS LONG, backcol AS LONG)

    '-------------------------DISPLAY----------------------------------------------------CLEARED
    ' SUB: Print_Arms
    '
    ' Purpose:
    ' Displays singular weapon element and manages mouse over events.
    '
    ' Passed Variables:
    ' var1 sends row number to display on
    ' var3 sends weapon element to be dsplayed
    ' textcol sends text color
    ' backcol sends background color
    '
    '------------------------------------------------------------------------------------

    'Print_Arms parameters
    temp_val% = var3.value
    short_dex% = char(6, ActPC).value - var3.dex
    short_str% = char(1, ActPC).value - var3.str
    IF short_dex% + (short_str% / 2) < 0 OR short_str% < 0 THEN
        temp_val% = Rounder(temp_val% / 2)
    END IF
    low_y = ((var1 - 1) * 16) - 1
    high_y = var1 * 16
    IF var3.modified > 0 THEN
        ct& = clr&(10): cb& = backcol
    ELSE
        ct& = textcol: cb& = backcol
    END IF
    COLOR ct& ', cb&

    'phantom box
    phtmbx& = _RGBA32(67, 100, 172, 30)
    IF mouse_y > low_y AND mouse_y < high_y THEN
        LINE (0, low_y)-(615, high_y), phtmbx&, BF
    END IF

    'experience check box
    IF mouse_y > low_y AND mouse_y < high_y AND mouse_x < 4 THEN COLOR clr&(12) ', clr&(0)
    LOCATE var1, 1
    IF var3.exchk = 1 THEN
        PRINT "[X]"
    ELSE
        PRINT "[ ]"
    END IF
    COLOR clr&(0)
    LOCATE var1, 1
    PRINT "                                                                                "
    COLOR ct& ',cb&

    'weapon name at tab 5
    IF MID$(var3.cate, 2, 2) = "H " THEN h$ = MID$(var3.cate, 1, 3) ' add handedness from category
    IF mouse_y > low_y AND mouse_y < high_y AND mouse_x > 31 AND mouse_x < 168 THEN COLOR clr&(12) ', clr&(0)
    LOCATE var1, 5: PRINT h$ + var3.name: h$ = "": COLOR ct& ', cb&
    'weapon strike rank at tab 24
    IF PC_skill(var3.link, ActPC).category = "miss" THEN
        strk = dexsr(ActPC)
    ELSE
        strk = var3.bsr + basesrm(ActPC)
    END IF
    LOCATE var1, 24: PRINT USING "##"; strk
    'weapon attack/parry percentage
    IF temp_val% < var3.value THEN COLOR clr&(14)
    IF mouse_y > low_y AND mouse_y < high_y AND mouse_x > 199 AND mouse_x < 240 THEN
        COLOR clr&(12) ', clr&(0)
        'code here for c/s/f popup placed ahead of ID position 66
        crit% = Rounder(temp_val% / 20): crit$ = LTRIM$(RTRIM$(STR$(crit%)))
        spec% = Rounder(temp_val% / 5): spec$ = LTRIM$(RTRIM$(STR$(spec%)))
        fumb% = 101 - Rounder((100 - temp_val%) / 20): fumb$ = LTRIM$(RTRIM$(STR$(fumb%)))
        IF fumb% >= 100 THEN fumb$ = "00"
        LOCATE var1, 67: PRINT crit$; "/"; spec$; "/"; fumb$
    END IF
    LOCATE var1, 28: PRINT USING "###"; temp_val%: COLOR ct& ', cb&
    'weapon damage
    LOCATE var1, 33: PRINT var3.damage
    'weapon encumbrance
    LOCATE var1, 41: PRINT var3.enc
    'weapon hit points / flashing when damaged
    IF var3.hpx < var3.hp THEN COLOR clr&(9)
    IF mouse_y > low_y AND mouse_y < high_y AND mouse_x > 359 AND mouse_x < 376 THEN COLOR clr&(12) ', clr&(0)
    LOCATE var1, 46: PRINT USING "##"; var3.hpx: COLOR ct& ', cb&
    'insufficient STR and/or DEX to use weapon
    IF short_dex% + (short_str% / 2) < 0 OR short_str% < 0 THEN
        COLOR clr&(14)
        LOCATE var1, 50
        PRINT USING "##"; short_str%
        LOCATE var1, 54
        PRINT USING "##"; short_dex%
        COLOR ct& ', cb&
    END IF
    'IF var3.init = 1 THEN
    '    LOCATE var1, 60
    '    PRINT "*"
    'END IF
    LOCATE var1, 75
    PRINT USING "##"; var3.ident


END SUB 'Print_Arms


SUB Recalc_Skills

    '-------------------------ALGORITHM--------------------------------------------------CLEARED
    ' SUB: Recalc_Skills
    '
    ' Purpose:
    ' Go through all skills after a characteristic change and recalculate any that change
    ' due to changes in the category modifiers. Repeat the process for weapon stats.
    '
    ' Passed variables:
    ' None
    '
    '------------------------------------------------------------------------------------

    FOR x = 1 TO UBOUND(PC_skill, 1)
        SELECT CASE PC_skill(x, ActPC).category
            CASE IS = "agil"
                Adjust_Mod x, Agil(ActPC)
            CASE IS = "comm"
                Adjust_Mod x, Communi(ActPC)
            CASE IS = "know"
                Adjust_Mod x, Know(ActPC)
            CASE IS = "magi"
                Adjust_Mod x, Magic(ActPC)
            CASE IS = "mani"
                Adjust_Mod x, Manip(ActPC)
            CASE IS = "perc"
                Adjust_Mod x, Percep(ActPC)
            CASE IS = "stlt"
                Adjust_Mod x, Stealth(ActPC)
            CASE IS = "mele"
                Adjust_Mod x, Melee(ActPC)
            CASE IS = "miss"
                Adjust_Mod x, Missile(ActPC)
            CASE IS = "natu"
                Adjust_Mod x, Natur(ActPC)
            CASE IS = "shld"
                Adjust_Mod x, Shield(ActPC)
        END SELECT
    NEXT x
    FOR x = 1 TO 56
        weap(x, ActPC).value = weap(x, ActPC).value + (Manip(ActPC) - weap(x, ActPC).cat_per)
        weap(x, ActPC).cat_per = Manip(ActPC)
    NEXT x
    Dodge_Jump

END SUB 'Recalc_Skills


SUB RefreshPrompt

    '-------------------------MAIN LOOP--------------------------------------------------CLEARED
    ' SUB: RefreshPrompt
    '
    ' Purpose:
    ' Main program user interface loop, monitoring hotkey and mouse input
    '
    ' Passed Variables:
    ' None
    '
    '------------------------------------------------------------------------------------

    mainloop:
    IF ActPC = 0 AND MaxPC = 0 THEN '                           no characters yet present? start one.
        ActPC = 1
        'MaxPC is updated by either SUB Load_PC or SUB Characteristic_In, so don't do it here.
    END IF
    RefreshScreen 1
    DO
        IF Char_In(ActPC) = 0 THEN
            PromptOut$ = "Characteristics/ Load/ Quit: "
        ELSE Char_In(ActPC) = 1
            PromptOut$ = "New/ Homeland/ Occupation/ Weapons/ Load/ Save/ Remove/ Quit: "
        END IF
        LOCATE 40, 1
        HighlightCaps PromptOut$, clr&(15), clr&(12) '           Display the appropriate command prompt
        keypresswait:
        OpChoice$ = UCASE$(INKEY$)

        IF MaxPC > 15 THEN m% = 1 ELSE m% = 0
        Mouse_Loop m%, MaxPC - 15, offact
        Mouse_Over_Active
        mouse_in = _MOUSEBUTTON(1)
        IF mouse_in = -1 THEN
            _AUTODISPLAY
            _DELAY .2
            Mouse_Ops _MOUSEX, mouse_y
            GOTO mainloop
        END IF

        IF OpChoice$ = "" THEN GOTO keypresswait
        SELECT CASE OpChoice$
            CASE IS = CHR$(0) + CHR$(72) '                      up arrow
                IF offact > 0 THEN offact = offact - 1
            CASE IS = CHR$(0) + CHR$(80) '                      down arrow
                offact = offact + 1
                IF offact > MaxPC - 15 THEN offact = MaxPC - 15
            CASE IS = "C" '                                     Initiate first PC
                IF Char_In(ActPC) = 0 THEN '                    if no PC present...(as any present would have characteristics)
                    Characteristic_In '                         input its characteristics
                END IF
            CASE IS = "L" '                                     Load PC
                Load_PC "I", 0
                Attributes ActPC '                              compute loaded PCs attributes
                Category_Mods ActPC '                           compute loaded PCs category modifiers
            CASE IS = "N" '                                     Initiate new PC
                IF MaxPC < 10 THEN
                    ActPC = MaxPC + 1
                    Characteristic_In
                ELSEIF MaxPC >= 10 THEN
                    Expand_PC_Count
                    ActPC = MaxPC + 1
                    Characteristic_In
                END IF
            CASE IS = "H" '                                     Homeland experience
                Homeland
            CASE IS = "O" '                                     Occupation experience
                Occupation
            CASE IS = "W" '                                     Weapons handling
                Init_Weapons
            CASE IS = "S" '                                     Save PC
                Save_PC
            CASE IS = CHR$(19) '                                Batch Save
                Batch_Save
            CASE IS = CHR$(12) '                                Batch Load
                Batch_Load
            CASE IS = "R" '                                     Remove PC
                Edit 4
            CASE IS = "Q" '                                     Quit
                SYSTEM
        END SELECT
        RefreshScreen 1
        _LIMIT 60
    LOOP

END SUB 'RefreshPrompt


SUB RefreshScreen (var AS INTEGER)

    '-------------------------DISPLAY----------------------------------------------------CLEARED
    '
    ' SUB: RefreshScreen
    '
    ' Purpose:
    ' Displays the primary user interface.
    '
    ' Passed Variables:
    ' None
    '
    '------------------------------------------------------------------------------------

    SCREEN disp_main
    _DEST disp_main
    CLS 2
    _PUTIMAGE (0, 0), back_main, disp_main
    _PRINTMODE _KEEPBACKGROUND
    COLOR clr&(14)
    FOR x = 1 TO 7 '                                            Characteristics
        LOCATE x, 1: PRINT char(x, ActPC).abrev; "-":
        IF char(x, ActPC).value > char(x, ActPC).max THEN
            COLOR clr&(12) ', clr&(1)
        END IF
        LOCATE x, 6: PRINT USING "##"; char(x, ActPC).value
        COLOR clr&(14) ', clr&(1)
    NEXT x

    LOCATE 1, 9: PRINT "| "; dambonus(ActPC); " DMG" '          Attributes
    LOCATE 2, 9: PRINT "| Heal Rt__": LOCATE 2, 19: PRINT USING "##"; healrate(ActPC)
    LOCATE 3, 9: PRINT "| Siz SR___": LOCATE 3, 19: PRINT USING "##"; sizsr(ActPC)
    LOCATE 4, 9: PRINT "| Hit Pts__": LOCATE 4, 19: PRINT USING "##"; hitpoints(ActPC)
    LOCATE 5, 9: PRINT "| Mg Pts___": LOCATE 5, 19: PRINT USING "##"; magpoints(ActPC)
    LOCATE 6, 9: PRINT "| Dex SR___": LOCATE 6, 19: PRINT USING "##"; dexsr(ActPC)
    LOCATE 7, 9: PRINT "| Base SR__": LOCATE 7, 19: PRINT USING "##"; basesrm(ActPC)

    '                                                           Location hit points
    LOCATE 1, 22: PRINT "| R Leg ": LOCATE 1, 30: PRINT USING "##"; LegHP(ActPC)
    LOCATE 2, 22: PRINT "| L Leg ": LOCATE 2, 30: PRINT USING "##"; LegHP(ActPC)
    LOCATE 3, 22: PRINT "| Abdom ": LOCATE 3, 30: PRINT USING "##"; AbdmHP(ActPC)
    LOCATE 4, 22: PRINT "| Chest ": LOCATE 4, 30: PRINT USING "##"; ChstHP(ActPC)
    LOCATE 5, 22: PRINT "| R Arm ": LOCATE 5, 30: PRINT USING "##"; ArmHP(ActPC)
    LOCATE 6, 22: PRINT "| L Arm ": LOCATE 6, 30: PRINT USING "##"; ArmHP(ActPC)
    LOCATE 7, 22: PRINT "|  Head ": LOCATE 7, 30: PRINT USING "##"; HeadHP(ActPC)

    '                                                           Category modifiers
    LOCATE 1, 33: PRINT "| Agility.......": LOCATE 1, 50: PRINT USING "###"; Agil(ActPC)
    LOCATE 2, 33: PRINT "| Communications": LOCATE 2, 50: PRINT USING "###"; Communi(ActPC)
    LOCATE 3, 33: PRINT "| Knowledge.....": LOCATE 3, 50: PRINT USING "###"; Know(ActPC)
    LOCATE 4, 33: PRINT "| Magic.........": LOCATE 4, 50: PRINT USING "###"; Magic(ActPC)
    LOCATE 5, 33: PRINT "| Manipulation..": LOCATE 5, 50: PRINT USING "###"; Manip(ActPC)
    LOCATE 6, 33: PRINT "| Perception....": LOCATE 6, 50: PRINT USING "###"; Percep(ActPC)
    LOCATE 7, 33: PRINT "| Stealth.......": LOCATE 7, 50: PRINT USING "###"; Stealth(ActPC)

    LOCATE 1, 54: PRINT "| Spirit Cmbt DMG= "; sprtcmbtdam(ActPC)
    LOCATE 2, 54: PRINT "| MAX ENC="; maxenc(ActPC)
    LOCATE 3, 54: PRINT "| Melee= "; Melee(ActPC)
    LOCATE 4, 54: PRINT "| Missile= "; Missile(ActPC)
    LOCATE 5, 54: PRINT "| Shield= "; Shield(ActPC)
    LOCATE 6, 54: PRINT "| Natural= "; Natur(ActPC)
    LOCATE 7, 54: PRINT "| ";
    Alter_Color MyHome(ActPC), 7, 56
    Alter_Color PCname(ActPC), 8, 1
    Alter_Color Occup(ActPC), 8, 56
    COLOR clr&(14)
    LOCATE 8, 33: PRINT "PC "; ActPC; " of "; MaxPC

    IF LEFT$(PCname(ActPC), 6) = "Click/" THEN '                If name hasn't been entered
        bsnm$ = "Unnamed #" + LTRIM$(STR$(ActPC)) '             build a temporary name from active PC number
    ELSE
        bsnm$ = LTRIM$(RTRIM$(PCname(ActPC))) '                 otherwise use PC's name
    END IF
    strt = 319 - (LEN(bsnm$) / 2) * 16 '                        compute starting position for display
    Prnt bsnm$, 2, strt, 688 - 35, 16, 0 '                      execute display of enlarged name at bottom of screen

    '                                                           MAN WITH HITPOINTS
    LINE (695, 15)-(733, 71), clr&(15), B '                     head
    x$ = LTRIM$(STR$(HeadHP(ActPC)))
    Prnt x$, 2, 700, 23, 8, 0
    LINE (687, 71)-(741, 119), clr&(15), B '                    chest
    x$ = LTRIM$(STR$(ChstHP(ActPC)))
    Prnt x$, 2, 700, 79, 8, 0
    LINE (687, 119)-(741, 167), clr&(15), B '                   abdomen
    x$ = LTRIM$(STR$(AbdmHP(ActPC)))
    Prnt x$, 2, 700, 127, 8, 0
    LINE (655, 71)-(687, 135), clr&(15), B '                    right arm
    x$ = LTRIM$(STR$(ArmHP(ActPC)))
    Prnt x$, 2, 655, 87, 8, 0
    LINE (741, 71)-(773, 135), clr&(15), B '                    left arm
    Prnt x$, 2, 741, 87, 8, 0
    LINE (679, 167)-(711, 231), clr&(15), B '                   right leg
    x$ = LTRIM$(STR$(LegHP(ActPC)))
    Prnt x$, 2, 679, 183, 8, 0
    LINE (719, 167)-(751, 231), clr&(15), B '                   left leg
    Prnt x$, 2, 719, 183, 8, 0

    _PUTIMAGE (664, 568), batload, disp_main '                  place batch load button
    _PUTIMAGE (664, 628), batsave, disp_main '                  place batch save button

    SELECT CASE var
        CASE IS = 1
            Display_Skills
        CASE IS = 2
            Display_Weapons
        CASE IS = 3
            ' Put nothing in the data window, used in a call from Display_Weapons or Mouse_List
    END SELECT

END SUB 'RefreshScreen


SUB RotoZoom2 (X AS LONG, Y AS LONG, Image AS LONG, xScale AS SINGLE, yScale AS SINGLE, Rotation AS SINGLE)

    '------------------------------------------------------------------------------------CLEARED
    ' SUB: RotoZoom2 (author Bplus of QB64 forum, not my own creation, but damn useful)
    '
    ' Purpose:
    ' Locate and display image, scaling and/or rotating the displayed image around
    ' its central point.
    '
    ' Passed parameters:
    ' X, Y sends the center point of where the image is to be displayed
    ' Image sends the source image handle
    ' xScale and yScale send width and height stretching parameters 1=original size
    ' Rotation sends rotation of image in degrees 0=east, 270=north
    '
    '------------------------------------------------------------------------------------

    DIM px(3) AS SINGLE: DIM py(3) AS SINGLE
    W& = _WIDTH(Image&): H& = _HEIGHT(Image&)
    px(0) = -W& / 2: py(0) = -H& / 2: px(1) = -W& / 2: py(1) = H& / 2
    px(2) = W& / 2: py(2) = H& / 2: px(3) = W& / 2: py(3) = -H& / 2
    sinr! = SIN(-Rotation / 57.2957795131): cosr! = COS(-Rotation / 57.2957795131)
    FOR i& = 0 TO 3
        x2& = (px(i&) * cosr! + sinr! * py(i&)) * xScale + X: y2& = (py(i&) * cosr! - px(i&) * sinr!) * yScale + Y
        px(i&) = x2&: py(i&) = y2&
    NEXT
    _MAPTRIANGLE (0, 0)-(0, H& - 1)-(W& - 1, H& - 1), Image& TO(px(0), py(0))-(px(1), py(1))-(px(2), py(2))
    _MAPTRIANGLE (0, 0)-(W& - 1, 0)-(W& - 1, H& - 1), Image& TO(px(0), py(0))-(px(3), py(3))-(px(2), py(2))

END SUB 'RotoZoom2


FUNCTION Rounder (var AS SINGLE)

    '------------------------------------------------------------------------------------CLEARED
    ' FUNCTION: Rounder
    '
    ' Purpose:
    ' Conditions rounding C/S/F display in Print_Arms to match RQG rules
    '
    ' Passed parameters:
    ' var sends argument to be rounded
    '
    '------------------------------------------------------------------------------------

    temp = var
    IF temp - INT(temp) >= .5 THEN
        temp = INT(temp) + 1
    ELSE
        temp = INT(temp)
    END IF
    Rounder = temp

END FUNCTION 'Rounder


SUB Save_PC

    '-------------------------ALGORITHM--------------------------------------------------CLEARED
    ' SUB: Save_PC
    '
    ' Purpose:
    ' Saves the present state of the active character.
    '
    ' Passed Variables:
    ' None
    '
    '------------------------------------------------------------------------------------

    Choosing_Screen '                                           40 x 17
    LOCATE 1, 16
    COLOR clr&(14)
    PRINT "SAVE PC"
    COLOR clr&(15)
    IF PCname(ActPC) <> "Click/Name" THEN
        filename$ = "data\" + PCname(ActPC) + ".pc1"
    END IF
    IF PCname(ActPC) = "Click/Name" THEN
        LOCATE 3, 8
        PRINT "Input name of character"
        LOCATE 5, 10
        INPUT "->", PCname(ActPC)
        filename$ = "data\" + PCname(ActPC) + ".pc1"
    END IF
    PRINT "Saving ";
    OPEN filename$ FOR OUTPUT AS #1
    WRITE #1, ver_p, ver_s, ver_t, PCname(ActPC), MyHome(ActPC), Occup(ActPC), Char_In(ActPC), Weap_In(ActPC)
    CLOSE #1
    PRINT ".";
    filename$ = "data\" + PCname(ActPC) + ".pc2"
    OPEN filename$ FOR RANDOM AS #2 LEN = LEN(char(1, ActPC))
    FOR x = 1 TO 7
        PUT #2, x, char(x, ActPC)
    NEXT x
    CLOSE #2
    PRINT ".";
    filename$ = "data\" + PCname(ActPC) + ".pc3"
    OPEN filename$ FOR RANDOM AS #3 LEN = LEN(PC_skill(1, ActPC))
    FOR x = 1 TO 115
        PUT #3, x, PC_skill(x, ActPC)
    NEXT x
    CLOSE #3
    PRINT ".";
    filename$ = "data\" + PCname(ActPC) + ".pc4"
    OPEN filename$ FOR RANDOM AS #4 LEN = LEN(weap(1, ActPC))
    FOR x = 1 TO 56
        PUT #4, x, weap(x, ActPC)
    NEXT x
    CLOSE #4
    LOCATE 10, 10
    PRINT filename$; " saved."

END SUB 'Save_PC


SUB Skill_Up (var1 AS INTEGER, var2 AS INTEGER)

    '-------------------------ALGORITHM--------------------------------------------------CLEARED
    ' SUB: Skill_Up
    '
    ' Purpose:
    ' Increment a singular skill by a determined amount and set the experience/training
    ' flag for that skill. Handle non-experience skills appropriately.
    '
    ' Passed Variables:
    ' var1 sends skill index
    ' var2 sends amount to increment to skill value
    '
    '------------------------------------------------------------------------------------

    PC_skill(var1, ActPC).value = PC_skill(var1, ActPC).value + var2
    IF PC_skill(var1, ActPC).base_per = 0 AND PC_skill(var1, ActPC).modified = 0 THEN
        PC_skill(var1, ActPC).value = PC_skill(var1, ActPC).value + PC_skill(var1, ActPC).cat_per
    END IF
    PC_skill(var1, ActPC).modified = PC_skill(var1, ActPC).modified + 1

END SUB 'Skill_Up


SUB Warrior_Heavy_Cavalry

    '-------------------------QUERY/DISPLAY----------------------------------------------CLEARED
    '
    ' SUB: Warrior_Heavy_Cavalry
    '
    ' Purpose:
    ' Conducts skill increases and unit weapons choices for heavy cavalry warrior
    ' occupation.
    '
    ' Passed Variables:
    ' None
    '
    '------------------------------------------------------------------------------------

    Occup(ActPC) = "Hvy Cav Warrior"
    Skill_Up 24, 30
    Skill_Up 34, 10
    Skill_Up 6, 35
    Skill_Up 71, 10
    Skill_Up 72, 10
    Skill_Up 18, 10

    RESTORE HvyCav_List '                                       all unit weapons +25
    cho% = Choose_Unit_Arms
    SELECT CASE cho%
        CASE 1
            Skill_Up 97, 25
            Skill_Up 93, 25: weap(33, ActPC).value = weap(33, ActPC).value + 25
            weap(33, ActPC).modified = weap(33, ActPC).modified + 1
            weap(33, ActPC).init = 1
            Category_Pull weap(33, ActPC)
            Weapon_Choice "1H", 25, "primary unit"
        CASE 2
            Skill_Up 93, 25: weap(33, ActPC).value = weap(33, ActPC).value + 25
            weap(33, ActPC).modified = weap(33, ActPC).modified + 1
            weap(33, ActPC).init = 1
            Category_Pull weap(33, ActPC)
            Skill_Up 108, 25
            Weapon_Choice "1H", 25, "primary unit"
        CASE 3
            Skill_Up 101, 25
            Skill_Up 93, 25: weap(33, ActPC).value = weap(33, ActPC).value + 25
            weap(33, ActPC).modified = weap(33, ActPC).modified + 1
            weap(33, ActPC).init = 1
            Category_Pull weap(33, ActPC)
            Weapon_Choice "1H", 25, "primary unit"
    END SELECT

    Weapon_Choice "ALL", 20, "secondary" '                      other weapon +20

END SUB 'Warrior_Heavy_Cavalry


SUB Warrior_Heavy_Infantry

    '-------------------------QUERY/DISPLAY----------------------------------------------CLEARED
    ' SUB: Warrior_Heavy_Infantry
    '
    ' Purpose:
    ' Conducts skill increases and unit weapons choices for heavy infantry warrior
    ' occupation.
    '
    ' Passed Variables:
    ' None
    '
    '------------------------------------------------------------------------------------

    Occup(ActPC) = "Hvy Inf Warrior"
    Skill_Up 18, 10
    Skill_Up 72, 10
    Skill_Up 24, 30
    Skill_Up 34, 15
    Skill_Up 71, 10

    'unit weapons +25
    RESTORE HvyInf_List
    cho% = Choose_Unit_Arms
    SELECT CASE cho%
        CASE 1
            Skill_Up 107, 25
            Weapon_Choice "1H", 25, "primary unit"
        CASE 2
            Weapon_Choice "2H", 25, "primary unit"
    END SELECT

    Weapon_Choice "ALL", 25, "secondary" '                      other weapon +25

    Weapon_Choice "ALL", 15, "tertiary" '                       tertiary weapon +15

END SUB 'Warrior_Heavy_Infantry


SUB Warrior_Light_Cavalry

    '-------------------------QUERY/DISPLAY----------------------------------------------CLEARED
    '
    ' SUB: Warrior_Light_Cavalry
    '
    ' Purpose:
    ' Conducts skill increases and unit weapons choices for light cavalry warrior
    ' occupation.
    '
    ' Passed Variables:
    ' None
    '
    '------------------------------------------------------------------------------------

    Occup(ActPC) = "Lt Cav Warrior"
    Skill_Up 6, 35
    Skill_Up 71, 10
    Skill_Up 18, 10
    Skill_Up 72, 10
    Skill_Up 24, 30
    Skill_Up 34, 10

    RESTORE LtCav_List '                                        all unit weapons +25
    cho% = Choose_Unit_Arms
    SELECT CASE cho%
        CASE 1
            Skill_Up 97, 25
            Skill_Up 109, 25
            Weapon_Choice "1H", 25, "primary unit"
        CASE 2
            Skill_Up 97, 25
            Skill_Up 93, 25: weap(33, ActPC).value = weap(33, ActPC).value + 25
            weap(33, ActPC).modified = weap(33, ActPC).modified + 1
            weap(33, ActPC).init = 1
            Category_Pull weap(33, ActPC)
            Weapon_Choice "1H", 25, "primary unit"
        CASE 3
            Skill_Up 101, 25
            Skill_Up 108, 25
            Weapon_Choice "1H", 25, "primary unit"
        CASE 4
            Skill_Up 93, 25: weap(33, ActPC).value = weap(33, ActPC).value + 25
            weap(33, ActPC).modified = weap(33, ActPC).modified + 1
            weap(33, ActPC).init = 1
            Category_Pull weap(33, ActPC)
            Skill_Up 109, 25
            Weapon_Choice "1H", 25, "primary unit"
        CASE 5
            Skill_Up 93, 25: weap(33, ActPC).value = weap(33, ActPC).value + 25
            weap(33, ActPC).modified = weap(33, ActPC).modified + 1
            weap(33, ActPC).init = 1
            Category_Pull weap(33, ActPC)
            Skill_Up 108, 25
            Weapon_Choice "1H", 25, "primary unit"
    END SELECT

    Weapon_Choice "ALL", 20, "secondary" '                      other weapon +20

END SUB 'Warrior_Light_Cavalry


SUB Warrior_Light_Infantry

    '-------------------------QUERY/DISPLAY----------------------------------------------CLEARED
    ' SUB: Warrior_Light_Infantry
    '
    ' Purpose:
    ' Conducts skill increases and unit weapons choices for light infantry warrior
    ' occupation.
    '
    ' Passed Variables:
    ' None
    '
    '------------------------------------------------------------------------------------

    Occup(ActPC) = "Lt Inf Warrior"
    Skill_Up 24, 30
    Skill_Up 34, 10
    Skill_Up 6, 35
    Skill_Up 71, 10
    Skill_Up 72, 10
    Skill_Up 18, 10

    RESTORE LtInf_List '                                        unit weapons +25
    cho% = Choose_Unit_Arms
    SELECT CASE cho%
        CASE 1
            Skill_Up 105, 25
            Skill_Up 109, 25
            Weapon_Choice "1H", 25, "primary unit"
        CASE 2
            Skill_Up 101, 25
            Skill_Up 108, 25
            Weapon_Choice "1H", 25, "primary unit"
        CASE 3
            Skill_Up 104, 25
            Skill_Up 108, 25
            Weapon_Choice "1H", 25, "primary unit"
        CASE 4
            Skill_Up 96, 25
            Skill_Up 108, 25
            Weapon_Choice "1H", 25, "primary unit"
    END SELECT

    Weapon_Choice "ALL", 25, "secondary" '                      other weapon +25

END SUB 'Warrior_Light_Infantry


SUB Weapon_Choice (var1 AS STRING, var2 AS INTEGER, var3 AS STRING)

    '-------------------------QUERY/DISPLAY----------------------------------------------CLEARED
    ' SUB: Weapon_Choice
    '
    ' Purpose:
    ' Conducts a choice dialog for weapons of certain martial occupations
    '
    ' Passed Variables:
    ' var1 sends weapon category from which to choose.
    ' var2 sends experience increment for the chosen weapon
    ' var3 sends "primary"/"secondary"/ etc. classifications of choices.
    '
    '------------------------------------------------------------------------------------

    SELECT CASE var1
        CASE IS = "1H"
            RESTORE Weap_1H
        CASE IS = "2H"
            RESTORE Weap_2H
        CASE IS = "ALL"
            RESTORE Weap_ALL
        CASE IS = "MS"
            RESTORE Weap_MS
    END SELECT

    READ last%
    DIM temp%(last%)
    FOR x = 1 TO last%
        READ temp%(x)
    NEXT x

    SCREEN oc_win '                                         Initiate Occupation window for weapons
    _DEST oc_win
    CLS
    _PUTIMAGE , back_main
    _PRINTMODE _KEEPBACKGROUND

    LOCATE 1, 10
    PRINT "Choose "; var3; " weapon (+"; var2; ")"
    DO
        FOR x = 1 TO last%
            IF INT((mouse_y - 15) / 16) = x AND mouse_x > 80 AND mouse_x < 304 THEN m_over = 1
            LOCATE x + 2, 10
            Color_Test LTRIM$(STR$(x)), temp%(x), m_over
            m_over = 0
        NEXT x

        Mouse_Loop 0, 0, 0
        x% = Mouse_Point(2, last%, 80, 304)
        _LIMIT 50
    LOOP UNTIL x% <> 0
    _DELAY .25

    Skill_Up temp%(x%), var2

END SUB 'Weapon_Choice


FUNCTION YesOrNo$ (question AS STRING)

    '-------------------------QUERY------------------------------------------------------CLEARED
    ' FUNCTION: YesOrNo$
    '
    ' Purpose:
    ' Display a question and wait for the user to type Y or N returning result to
    ' calling routine for further processing. A standard library function that is used
    ' to verify deletion of an active PC.
    '
    ' Passed Variables:
    ' question sends displayed prompt for Yes or No choice
    '
    '------------------------------------------------------------------------------------

    PRINT question;
    DO
        answer$ = UCASE$(INKEY$)
    LOOP UNTIL answer$ = "Y" OR answer$ = "N"
    PRINT answer$

    YesOrNo$ = answer$

END FUNCTION 'YesOrNo$
